var tplBaseUrl = "";
var eportalConfig = appcan.getLocVal("EPORTAL_CONFIG");
eportalConfig = JSON.parse(eportalConfig);
var masUrl = eportalConfig.mas_emm;
var isSaas = parseInt(eportalConfig.isSaas);
var appId = "sdk11106";
function loadTemplate(tpl,cb) {
    var template = null;
    $.ajax({
        url : tplBaseUrl + tpl,
        type : 'GET',
        data : {}, //默认从参数获取
        timeout : 10000,
        async : false,
        success : function(data) {
            template = _.template(data);
            if(cb) cb(template);
        },
        error : function(e) {
            if(cb) cb(template);
        }
    });
    return template;
}
function getEpotalConfig(){
    eportalConfig = appcan.getLocVal("EPORTAL_CONFIG");
    eportalConfig = JSON.parse(eportalConfig);
    masUrl = eportalConfig.mas_emm;
    isSaas = parseInt(eportalConfig.isSaas);
}
var storeKey = {
    PERSON_INFO:"perInfo",
    PERSON_INFO_ICON:"userIconUrlIndex",
    PERSON_ID:"yghao",
    PERSON_NAME:"ygname",
    CONTACT_NAME:"contactsName",
    CONTACT_ICON:"conImg",
    TENTANTCOUNT:"tentantCount",
}
var tenant = appcan.getLocVal(storeKey.TENTANTCOUNT);
var constant = {
    IMG_URL : "",
    APP_URL : masUrl + "emoa/app",
    LOGIN_URL : masUrl + "emoa/appLogin",
    MSG_URL:masUrl + "emoa/message",
    APP_ID:appId,
}

var tools = {
    TEL_REG : /^1[3|4|5|7|8][0-9]\d{4,8}$/,//手机
    EMAIL_REG :  /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/,
    PHONE_REG : /^([0-9]{3,4}-)?[0-9]{7,8}$/,//座机
}
function ALERT_ERROR(mod, fun, msg) {
    //window.alert(mod + "\r\n" + fun + "\r\n" + msg);
}

function global_error(error) {
    appcan.window.openToast(error.msg.message, 1500, 5);
}
function getHeader() {
    return JSON.stringify({
        "x-mas-app-id" : constant.APP_ID
    });

}
/**
 *service的基础对象，供其他service调用
 */
var BaseService = {
    /**
     *获取请求锁
     * @param {Object} string
     */
    getLockKey : function(string) {
        if (string) {
            //有option对象，把它变成字符串
            string = encodeURI(string);
            var md5 = appcan.crypto.md5(string);
            return md5;
        }
    },
    emmCall:function(url, type, data, option){

    },
    /**
     *简化普通请求
 * @param {Object} url
 * @param {Object} type
 * @param {Object} data
 * @param {Object} option
     */
    ajaxCall : function(url, type, data, option) {
        var self = this;
        var lockKey = self.getLockKey(JSON.stringify(data));
        if (self[lockKey]) {
            //如果锁定请求的话，不再提交
            self.trigger("error", "Request alreay running. Please wait");
            return;
        }
        //加请求锁
        self[lockKey] = true;
        //调试的话，建议用$.ajax，生产环境可以用appcan.ajax
        //$.ajax({
        appcan.request.ajax({
            url : url,
            type : type,
            data : data,
            header:getHeader(),
            contentType : "application/json",
            success : function(data) {
                data=JSON.parse(data);
                self[lockKey] = false;
                if (data.status == '000') {
                    option.success(data);
                } else {
                    option.error(new Error(data.message));
                }
            },
            error : function(e, err) {
                self[lockKey] = false;
                option.error(new Error(err));
            }
        });
    }
};
_.extend(BaseService, Backbone.Events);

