//岗位职责
var jobDutiesModel = Backbone.Model.extend({
    initialize : function(id) {
        //初始化模版需要的service
        this.set({"dptId":"加载中","dptName":"加载中","postId":"加载中","postName":"加载中","jobDuty":"加载中","keyKpl":"加载中"})
        this.service=jobDutiesService;
        this.listenTo(this.service, "error", function(list) {
           //alert('1111')
        })
    },
    /**
     *service返回处理,为前端取值减少层级 
 * @param {Object} resp
     */
    parse : function(resp) {
        var rep;
        if(resp.msg&&resp.msg.item){
            rep=resp.msg.item;
        }else if(resp.msg){
            //如果没有职责的话，写死对象，这个service改还是model改都可以
            rep={"dptId":"暂无","dptName":"暂无","postId":"暂无","postName":"暂无","jobDuty":"暂无","keyKpl":"暂无"}
        }
        return rep;
    },
    sync : function(method, model, options) {
        switch(method) {
        case "create":
        case "update":
        case "patch":
            break;
        case "read":
            //假数据
            //this.service.requestStub({}, options);
            this.service.request({}, options);
            break;
        case "delete":
            break;
        default:
            break;
        }
    }
})
