
var versionModel = Backbone.Model.extend({
     idAttribute : "sortVersion"
})

var versionCollection = Backbone.Collection.extend({
    initialize : function() {
        this.listenTo(versionService, "CB_GET_STORE_APP_VERSION_INFO", function(list) {
            if (this.options) {
                //var d = JSON.parse(list);
                if (list.status == "ok") {
                    this.options.success(list.info.appPkgInfo);
                } else {
                    this.options.error({status:-30002,msg:{message:list.info}});
                }
            }
        })
    },
    model : versionModel,
    parse : function(resp) {
        return resp;
    },
    sync : function(method, model, options) {
        this.options = options;
        switch(method) {
        case "create":
        case "update":
        case "patch":
            break;
        case "read":
            versionService.request(options);
            break;
        case "delete":
            break;
        default:
            break;
        }
    }
})