var loginView = Backbone.View.extend({//options...
    initialize : function() {
        this.stickit();
        var self = this;
        appcan.button("#btn", "btn-act", function() {
            self.$el.submit();
        })
        appcan.button(".pswCheck", "btn-act", function() {
            var isTure = $(".check2").hasClass("uhide");
            if (isTure) {
                $(".check2").removeClass("uhide");
                $(".check1").addClass("uhide");
            } else {
                $(".check1").removeClass("uhide");
                $(".check2").addClass("uhide");
            }
        })
        
        // $("#username").onchange=function(){
            // this.model.set("loginPass","");
        // }
    },

    model : new loginModel(),
    el : '#login',
    events : {
        'submit' : 'submitLogin',
    },
    bindings : {
        "#username" : {
            observe : 'loginName',
            updateModel : 'validUname',
            onGet:function(v){
                var loginName = v;
                if (!isSaas && v && mailSuffix) {
                    var loginName = v.substring(0, v.indexOf(mailSuffix));
                    return loginName;
                }
                return loginName;
                
            },onSet:function(v){
                // if(v && mailSuffix && v.indexOf("@")>0){
                    // var name = v.substring(0, v.indexOf('@'));
                    // return name;
                // }
                return v;
            }
        },
        "#password" : "loginPass",
        "#domainName" : {
            observe : "domainName",
        }
    },
    validUname : function(val, event, options) {
        return true;
    },
    lock : false,
    submitLogin : function() {
        if (!this.model.isValid()) {
             appcan.window.openToast(this.model.validationError,1500,5);
            return false;
        }
        
        var self = this;
        if(self.lock){
            return false;
        }
        self.lock = true;
        $("#username")[0].blur();
        $("#password")[0].blur();
       // alert(JSON.stringify(this.model.toJSON()))
        //this.model.set("loginName",loginNameSub(this.model.get("loginName")));
        appcan.window.openToast('登录中');
        this.model.save({}, {
            success : function(model, resp, options) {
                self.lock = false;
                if(isSaas && !isTest){
                    var tenant = (appcan.getLocVal(storeKeys.TENTANTCOUNT)).toLowerCase();
                    setConfig({mas_emm:'https://saas.appcan.cn/'+tenant+"/mobileoa/"})
                }
                appcan.window.closeToast();
                appcan.setLocVal("EMM_USER_INFO",resp);
                appcan.window.evaluateScript("root", "initIm()");
                // $(".check1").removeClass("uhide");
                // $(".check2").addClass("uhide");
                // $("#username").val("");
                appcan.window.openToast("数据载入中");
                if(isAndroid)
                appcan.window.open("index", "index.html", 10,64);
                else{
                   appcan.window.open("index", "index.html", 10); 
                }
                uexMDM.login(); 
            },
            error : function(model, error, options) {
                self.lock = false;
               appcan.window.closeToast();
               switch(error.status)
                {
                    default:
                    global_error(error);
                    break;
                }
               
            }
        });
        return false;
    }
});

var tentantView = Backbone.View.extend({//options...
    initialize : function() {
        this.stickit();
        var self = this;
        appcan.button("#next", "btn-act", function() {
            self.$el.submit();
        })
        
    },

    model : new tentantModel(),
    el : '#tenantForm',
    events : {
        'submit' : 'submitLogin',
    },
    bindings : {
        "#tenant" : "tenantAccount",
    },
    validUname : function(val, event, options) {
        return true;
    },
    lock : false,
    submitLogin : function() {
        if (!this.model.isValid()) {
             appcan.window.openToast(this.model.validationError,1500,5);
            return false;
        }
        var self = this;
        if(self.lock){
            return false;
        }
        self.lock = true;
        $("#tenant")[0].blur();
        appcan.window.openToast('提交中');
        appcan.setLocVal(storeKeys.TENTANTCOUNT,this.model.get("tenantAccount"));
        uexEMM.widgetStartReport(JSON.stringify(this.model.toJSON())); 
        return false;
    },
    initEmmApp : function(){
        try{
            var self = this;
              uexEMM.cbGetTenantAccount = function (opId,dataType,data){
                  if(data && data.indexOf("null")<0){
                      tenant = data;
                      appcan.setLocVal(storeKeys.TENTANTCOUNT,data);
                      $("#loginform").removeClass("uhide")
                      $("#tenantform").addClass("uhide")
                      $("#tenant").val(tenant);
                      self.model.set({"tenantAccount":tenant},{silent: true})
                  }else{
                      $("#loginform").addClass("uhide");
                      $("#tenantform").removeClass("uhide")
                  }
              }
              uexEMM.getTenantAccount();
            
        }catch(e){
        }
    },
    getProperty:function (){
        uexEMM.cbGetLoginProperty=function(opId,dataType,data){
            appcan.window.closeToast();
            var data=JSON.parse(data);
            if(data.status == "ok"){
                $("#tenantform").addClass("uhide");
                $("#loginform").removeClass("uhide");
                domainName = data.info.domains[0].domainName;
                setConfig({domainName:domainName});
                loginViewInstance.model.set("domainName",domainName);
            }else{
                appcan.window.openToast(data.info, 1500, 5);
            }
        }
        uexEMM.getLoginProperty()
    }
});
var loginViewInstance = new loginView();
if(isSaas){
    var tentantViewInstance = new tentantView();
}
appcan.ready(function() {
    if(isSaas){
        tentantViewInstance.initEmmApp();
        $("#change").removeClass("uhide");
        appcan.window.evaluateScript("root", "initEMM()"); 
    }
   appcan.window.subscribe("indexClose",function(a){
       loginViewInstance.model.set("loginPass","");
    });
    document.documentElement.style.webkitTouchCallout = 'none';
    //监听返回键
    uexWindow.onKeyPressed = function(keyCode) {
        if (keyCode == '0') {
            uexWidget.finishWidget('');
        }
    }
    uexWindow.setReportKey('0', '1');
    appcan.window.subscribe("EMM_REPORT_COMPLETE",function(d){
        appcan.window.closeToast();
        var data=JSON.parse(d);
        tentantViewInstance.lock = false;
          if((data.status=='ok')){
             tentantViewInstance.getProperty();
          }else {
              if($("#tenantform").hasClass("uhide")){
                  $("#loginform").removeClass("uhide")
              }
          }
    })
    appcan.button("#change", "btn-act", function() {
        $("#tenantform").removeClass("uhide");
        $("#loginform").addClass("uhide");

    })
});