var personCenterView = Backbone.View.extend({//options...
    initialize : function() {
        try{
            var staffId = appcan.getLocVal("userIdIm");
            this.model = new userInfoModel({}, {
                        userId : staffId
                    });
            this.updateData();
        }catch(e){
            ALERT_ERROR("personCenterView","initialize",e.message+'--'+e.stack)
        }
    },
    el : '#userInfo',
    load : function() {
        var staffId = appcan.getLocVal("userIdIm");
        var self = this;
       self.model.fetch({
            success : function(model, resp, options) {
                self.updateData()
                appcan.window.closeToast();
                appcan.frame.resetBounce(0);
            },
            error : function(model, error, options) {
                appcan.frame.resetBounce(0);
                appcan.window.closeToast();
            },staffId:staffId
        });
    },
    updateData : function(){
        var  info = this.model.toJSON();
        if(JSON.stringify(info) == "{}"){
            return;
        }
        appcan.setLocVal(storeKey.PERSON_INFO, JSON.stringify(info));
        var imgIcon = info.userIcon;
        var uname = info.fullName;
        var roleName = info.roleName;
        var dptName = info.dptName;
        var lastNameStr = '';
        var lastName = uname.substring((uname.length)-1,uname.length);
        var lastNameSP = shouPin.getCamelChars(lastName);
        lastNameStr = '<div style="font-size:1.5em;text-align:center;color:#ffffff;">'+lastName+'</div>';
        $('div.lazy').css("background-color",generateColor(lastNameSP));
        $('div.lazy').html(lastNameStr);
        if(imgIcon){
            $("div.lazy").data("original", constant.IMG_URL + imgIcon)
            appcan.ready(function(){
                $("div.lazy").lazyload({
                     cache : true,
                    callBack : function(path,s){
                        s.dom.css('background-image','url("' + path + '")');
                        s.dom.empty();
                    }
                 });
            })

        }
        $("#fullName").html(uname);
        $("#roleName").html(roleName);
        $("#dptName").html(dptName);
    }
});
var personCenterViewInstance = new personCenterView();
