var config = appcan.getLocVal("EPORTAL_CONFIG");
config = JSON.parse(config);
var server_emm = config.mas_emm;
var contact_emm = config.contact_emm;
var appId = config.appId;
var domainName = config.domainName;
var isSaas = parseInt(config.isSaas);

var imgUrl = "";
var url = server_emm + "emoa/app";
var ssoUrl = server_emm + "emoa/sso";
var uploadHttp = "";
var contactUrl = contact_emm;
var isAndroid = (window.navigator.userAgent.indexOf('Android') >= 0) ? true : false;


var isSML = (window.navigator.platform == 'Win32') ? 1 : 0;
function get_header() {
    return JSON.stringify({
        "x-mas-app-id" : appId
    });
}

function isDefine(para) {
    if ( typeof para == 'undefined' || $.trim(para) == "" || para == "[]" || para == null || para == undefined || para == 'undefined' || para == '[]')
        return false;
    else
        return true;
}

function closewin() {
    appcan.window.close(-1);
}


//获取年份//获取月份//获取日期
function NYR(date, flag) {
    // date = date.replace(/-/g,'/');
    var da = new Date(date);
    if (isDefine(flag)) {
        if (flag == 1) {
            return da.getFullYear() + "-" + ((da.getMonth() + 1) < 10 ? "0" + (da.getMonth() + 1) : (da.getMonth() + 1)) + "-" + (da.getDate() < 10 ? "0" + da.getDate() : da.getDate());
        } else {
            return ((da.getMonth() + 1) < 10 ? "0" + (da.getMonth() + 1) : (da.getMonth() + 1)) + "-" + (da.getDate() < 10 ? "0" + da.getDate() : da.getDate());
        }

    } else {
        return da.getFullYear() + "年" + ((da.getMonth() + 1) < 10 ? "0" + (da.getMonth() + 1) : (da.getMonth() + 1)) + "月" + (da.getDate() < 10 ? "0" + da.getDate() : da.getDate()) + "日";
    }
}

//获取小时//获取分
function HM(date) {
    var da = new Date(date);
    var hour = da.getHours();
    if (hour < 10) {
        hour = "0" + hour;
    }
    var minutes = da.getMinutes();
    if (minutes < 10) {
        minutes = "0" + minutes;
    }
    return hour + ":" + minutes
}

//2015-02-06T19:28:14.815Z
function toUTC(str) {
    str = str.replace(/-/g, "/");
    var str = new Date(str);
    return str.getUTCFullYear() + "-" + formatNum(str.getUTCMonth() + 1) + '-' + formatNum(str.getUTCDate()) + 'T' + formatNum(str.getUTCHours()) + ":" + formatNum(str.getUTCMinutes()) + ":" + formatNum(str.getUTCSeconds()) + '.' + formatNum(str.getUTCMilliseconds()) + 'Z';
}

function formatNum(d) {
    if (Number(d) < 10) {
        return "0" + d;
    } else {
        return d;
    }
}

//上传
function uploadFile(dirPath, cb) {
    var emmObj = appcan.getLocVal("emmObj");
    // var uploadHttp = "http://192.168.1.81:8080/3.0/files";
    // var uploadHttp="http://42.96.170.158:8080/3.0/files";
    // var uploadHttp = "http://119.253.41.171:9880/3.0/files";
    var num = appcan.getOptionId();
    //生成随机数
    //appcan.logs("生成的随机数num"+num);
    appcan.ready(function() {
        uexUploaderMgr.onStatus = function(opCode, fileSize, percent, serverPath, status) {
            //  appcan.logs("状态"+status);
            switch (status) {
            case 0:
                //上传中
                appcan.window.openToast('文件上传中' + percent + '%', 0, 5);
                break;
            case 1:
                appcan.window.openToast('文件上传成功', 3000, 5);
                // appcan.logs("121212"+eval('('+serverPath+')').msg.objectId);
                var serverUrl = eval('(' + serverPath + ')').msg.objectId;
                cb(serverUrl);
                uexUploaderMgr.closeUploader(num);
                break;
            case 2:
                //  appcan.logs(222222222);
                appcan.window.openToast('文件上传失败', 3000, 5);
                //uexUploaderMgr.closeUploader(num);
                // appcan.window.closeToast();
                uexUploaderMgr.closeUploader(num);
                break;
            }

        }
        uexUploaderMgr.cbCreateUploader = function(opCode, dataType, data) {
            if (data == 0) {
                appcan.logs("创建上传对象成功,开始上传文件");
                uexUploaderMgr.uploadFile(num, dirPath, "inputName", 4);
            } else {
                alert("创建失败");
            }
        }
    });
    uexUploaderMgr.createUploader(num, uploadHttp);

}

var imgCache = null;
appcan.ready(function() {
    //imgCache=appcan.icache({maxtask:3});
    try{uexWindow.disturbLongPressGesture(1);}catch(e){};
})

function loadImage(url, dom, sus) {
    if(imgCache)
    {
       imgCache.run({url:url,success:(sus?sus:''),dom:dom,header:get_header()});
    }
};
function mas_result_do(data){
    if (!data.dispose) {
        switch(data.status) {
        case 14504:
            appcan.window.publish('TOKENOUTOFFLOGIN','');
            return true;
        
        case '000':
            return false;
        }
        return false;
    }
     if(data.dispose.status == "L001"){
         appcan.window.publish('TOKENOUTOFFLOGIN','');
         return true;
     }
     return false;
}

//阿拉伯数字转换成中文数字
function spJishu(step) {
    switch(parseInt(step)) {
    case 1:
        return "一";
        break;
    case 2:
        return "二";
        break;
    case 3:
        return "三";
        break;
    case 4:
        return "四";
        break;
    case 5:
        return "五";
        break;
    case 6:
        return "六";
        break;
    case 7:
        return "七";
        break;
    case 8:
        return "八";
        break;
    case 9:
        return "九";
        break;
    default:
        break;
    }
}



function zy_parse(){
    var params = {};
    var loc = String(document.location);
    if (loc.indexOf("?") > 0) 
        loc = loc.substr(loc.indexOf('?') + 1);
    else 
        loc = uexWindow.getUrlQuery();
    if(loc){
        loc = String(loc);
        if(loc.indexOf("&")>0){
            var pieces = loc.split('&');
        }else{
            var pieces = [loc];
        }
    params.keys = [];
    for (var i = 0; i < pieces.length; i += 1) {
        var keyVal = pieces[i].split('=');
        
        params[keyVal[0]] = decodeURIComponent(keyVal[1]);
        params.keys.push(keyVal[0]);
    }}
    return params;
}
 appcan.ready(function() {
     if(!uexWindow.topBounceViewRefresh){
        uexWindow.topBounceViewRefresh=function(){
             uexWindow.onBounceStateChange(0,2);
        }
    }
});