var chatGroupModel = Backbone.Model.extend({
    idAttribute : "msgId"
})

var chatGroupCollection = Backbone.Collection.extend({
    initialize : function() {
        
        this.listenTo(chatListViewService, "E_XMPP_CB_GETGROUPCHATLIST", function(list) {
            if (this.options) {
                if(this.options.t==0){
                    var list = list.dataList.reverse();
                    this.options.success(list);
                }else{
                    this.options.success(list.dataList);
                }
            }
        })
       // this.reset(JSON.parse(appcan.locStorage.getVal("CHATLIST_STORAGE")|| "[]") );
    },
    model : chatGroupModel,
    service : chatListViewService, //服务，负责处理数据交互
    parse : function(resp) {
        return resp;
    },
    sync : function(method, model, options) {
        this.options = options;
        switch(method) {
        case "create":
        case "update":
        case "patch":
            break;
        case "read":
            chatListViewService.request({}, options);
            break;
        case "delete":
            break;
        default:
            break;
        }
    }
})
