//加载并初始化模板对象
var chatTextLeftTemplate = loadTemplate("assets/templates/chatTextLeft.tpl");
var chatTextRightTemplate = loadTemplate("assets/templates/chatTextRight.tpl");
var chatPicRightTemplate = loadTemplate("assets/templates/chatPicRight.tpl");
var chatPicLeftTemplate = loadTemplate("assets/templates/chatPicLeft.tpl");
var chatVoiceRightTemplate = loadTemplate("assets/templates/chatVoiceRight.tpl");
var chatVoiceLeftTemplate = loadTemplate("assets/templates/chatVoiceLeft.tpl");
var chatFileRightTemplate = loadTemplate("assets/templates/chatFileRight.tpl");
var chatFileLeftTemplate = loadTemplate("assets/templates/chatFileLeft.tpl");

var chatView = Backbone.View.extend({//options...
    initialize : function(option) {
        //this.userModel = new userInfoModel(this.model.imId);
        this.model.view = this;
        this.render();
        //this.listenTo(this.userModel, "change", this.updateUserInfo);
    },
    render : function() {
        try{
        var self = this;
        //获取是发送者还是接受者;0是接受者 1是发送者
        var isSend = self.model.get("isSend");
        //1-发送中，2-发送成功，3-发送失败。
        var sendStatus = self.model.get("sendStatus");
        //消息类型，1-文本；2-图片；3-语音；
        var msgType = self.model.get("msgType");
        var msgSender = self.model.get("msgSender");
        var msgId = self.model.get("msgId");
        if(isSend){
            var dparam = {
                imId : chatListViewInstance.chatId,
                msgId : msgId
            }
        }else
        var dparam = {
            imId : msgSender,
            msgId : msgId
        }
        var dparams = JSON.stringify(dparam);
        appcan.logs("--chat----" + JSON.stringify(self.model.toJSON()))
        var obj = {
            data : self.model.attributes,
            formatContent : function(d){
                if(d=='' || d==null || !isDefine(d)){
                    return ''
                }
              if(d.indexOf("长按消息加入:") > -1){
                d = d.split(':')[0];
              }
              d = replaceURLToLink(d);
              d = replacePhoneToCall(d);
              d = d.replace(tools.IM_EXPRESSION,self.change);
              d = d.replace(/wgtRes/g,chatListViewInstance.path);
              if(msgType==10){//图文混排
                  var start = '<img style="min-width:1px;min-height:1px;max-width:7.5em;max-height: 7.5em;border-radius: .2em;background-color:white;border: 0" class="pic lazy piclist" ';
                  d = d.replace(/&lt;img(.*)src=(.*)\/&gt;/ig,function(a){
                      a = a.replace(/&quot;/g,"'").replace(/src=[\'\"]?([^\'\"]*)[\'\"]?/i,function(b){
                        c = b.substring(b.indexOf("=")+1);
                        return  " data-original="+c+" ";
                      }).replace("&lt;img",start)
                      return a;
                  }).replace(/&gt;/g,">").replace(/&lt;/g,"<").replace(/&nbsp;/g," ").replace(/&quot;/g,"'");
              }
              d = d.replace(/\n/g,"<br>")
              return d;
            },
            setName:function(userId){
               // return userId;
                return chatListViewInstance.chatName;
            },
            dealIconChatName:function(userId){
                if (chatListViewInstance.chatIcon){
                    if(chatListViewInstance.chatIcon.indexOf("icache")>0 && chatListViewInstance.chatIcon.indexOf("http")!=0){//已下载
                        return "";
                    }
                }
                var name = chatListViewInstance.chatName;
                var lastName = name.substr((name.length)-1,1);
                var lastNameStr = '<div style="line-height:2.5em; text-align:center;color:#ffffff;">'+lastName+'</div>';
                return lastNameStr;
            },
            dealIconName:function(){
                if (chatListViewInstance.selfIcon){
                    if(chatListViewInstance.selfIcon.indexOf("icache")>0 && chatListViewInstance.selfIcon.indexOf("http")!=0){//已下载
                        return "";
                    }
                }
                var name = chatListViewInstance.selfName;
                var lastName = name.substr((name.length)-1,1);
                var lastNameStr = '<div style="line-height:2.5em; text-align:center;color:#ffffff;">'+lastName+'</div>';
                return lastNameStr;
            },
            dealIcon : function(){
                var name = chatListViewInstance.selfName;
                var lastName = name.substr((name.length)-1,1);
                var lastNameSP = shouPin.getCamelChars(lastName);
                if (chatListViewInstance.selfIcon){
                    if(chatListViewInstance.selfIcon.indexOf("icache")>0 && chatListViewInstance.selfIcon.indexOf("http")!=0){//已下载
                        var str = ' "style="background-image:url('+chatListViewInstance.selfIcon+')!important;background-color:'+generateColor(lastNameSP);
                        return str;
                    }
                    return 'lazy selfIcon" style="background-color:'+generateColor(lastNameSP)+'" data-original="' + constant.IMG_URL + chatListViewInstance.selfIcon;
                }

                return 'lazy selfIcon"style="background-color:'+generateColor(lastNameSP);
            },
            dealIconChat : function(){
                var name = chatListViewInstance.chatName;
                var lastName = name.substr((name.length)-1,1);
                var lastNameSP = shouPin.getCamelChars(lastName);
                if (chatListViewInstance.chatIcon){
                    if(chatListViewInstance.chatIcon.indexOf("icache")>0 && chatListViewInstance.chatIcon.indexOf("http")!=0){//已下载
                        var str = ' "style="background-image:url('+chatListViewInstance.chatIcon+')!important;background-color:'+generateColor(lastNameSP);
                        return str;
                    }
                    return 'lazy chatIcon" style="background-color:'+generateColor(lastNameSP)+'" data-original="' + constant.IMG_URL + chatListViewInstance.chatIcon;
                }
                return 'lazy chatIcon"style="background-color:'+generateColor(lastNameSP);
            },resPath:function(path){
                var lujing = path.substring((path.lastIndexOf("/"))+1,path.length);
                if(lujing.length>12){
                     var lujing1 = lujing.substring((lujing.lastIndexOf(".")),lujing.length);
                     lujing = lujing.substring(0,8)+"..."+lujing.substring(lujing.lastIndexOf(".")-4,lujing.lastIndexOf("."))+lujing1;
                }
                return lujing;
            },
            fileName:function(file){
                var lujing = file;
                if(lujing.length>12){
                    var lujing1 = lujing.substring((lujing.lastIndexOf(".")),lujing.length);
                    lujing = lujing.substring(0,8)+"..."+lujing.substring(lujing.lastIndexOf(".")-4,lujing.lastIndexOf("."))+lujing1;
                }
                return lujing;
            },
            loadStatu:function(dlstatus){
                var dlStatus;
                if (dlstatus==0) {
                    dlStatus="未下载";
                }else if (dlstatus==1) {
                    dlStatus="下载中";
                }else if (dlstatus==2) {
                    dlStatus="下载完成";
                }else if(dlstatus==3){
                    dlStatus="下载失败";
                };
                return dlStatus;
            }

        }
        if(isSend){
            switch(msgType){
                case 10://图文混排
                case 1://文本
                self.$el = $(chatTextRightTemplate(obj));
                break;
                case 2://图片
                self.$el = $(chatPicRightTemplate(obj));
                break;
                case 3://语音
                {
                    self.$el = $(chatVoiceRightTemplate(obj));
                    var dura = self.model.get("voiceTime");
                    var dura = Number(dura);
                    if (dura <= 3) {
                        $(".voice", self.$el).css('width', '3.5em');
                    } else if (3 < dura <= 60) {
                        var dur = 3.5 + (dura - 3) * 0.1;
                        $(".voice", self.$el).css('width', dur + 'em');
                    }
                    appcan.button($(".audioPlay", self.$el), "ani-act", function() {
                        var path = $(this).find("div.uhide").html();
                        uexAudio.stop();
                        var $currPlayBtn = $(this).find("div.yuyinImg");
                        $currPlayBtn.removeClass('yuyin2').addClass('yuyin2Gif');
                        self.baseView.$currPlayBtns.push($currPlayBtn);
                        self.playBgRecord(path);
                    });
                }
                break;
                case 7://文件
                {
                    self.$el = $(chatFileRightTemplate(obj));
                    appcan.button($(".fileMgr",self.$el), "", function(a) {
                        var path = this.id;
                        if (path== undefined) {
                        } else {
                            uexDocumentReader.openDocumentReader(path);
                        }
                    });
                }
                break;
                default:
                break;
            }
        }else{
            switch(msgType){
                case 10://图文混排
                case 1://文本
                self.$el = $(chatTextLeftTemplate(obj));
                break;
                case 2://图片
                self.$el = $(chatPicLeftTemplate(obj));
                if((self.model.get("dlstatus")) == 0){
                   uexIM.downloaderChatMgr(dparams);
                }
                break;
                case 3://语音

                {
                    self.$el = $(chatVoiceLeftTemplate(obj));
                    var dura = self.model.get("voiceTime");
                    var dura = Number(dura);
                    if (dura <= 3) {
                        $(".voice", self.$el).css('width', '3.5em');
                    } else if (3 < dura <= 60) {
                        var dur = 3.5 + (dura - 3) * 0.1;
                        $(".voice", self.$el).css('width', dur + 'em');
                    }
                    if ((self.model.get("dlstatus"))== 0) {
                        uexIM.downloaderChatMgr(dparams);
                    }
                    appcan.button($(".audioPlay", self.$el), "ani-act", function() {
                        var opacity = $(this).css("opacity");
                        if (opacity == "0.4") {
                            return;
                        } else {
                            var path = $(this).find("div.uhide").html();
                            $(this).siblings("div.yuand").removeClass("yuand");
                            var msgSender = self.model.get("msgSender");
                            var msgId = self.model.get("msgId");
                            var params = {
                                imId : msgSender,
                                msgId : msgId
                            }
                            var params1 = JSON.stringify(params)
                            uexIM.setVoiceMsgRead(params1);
                            uexAudio.stop();
                            var $currPlayBtn = $(this).find("div.yuyinImg");
                            $currPlayBtn.removeClass('yuyin').addClass('yuyinGif');
                            self.baseView.$currPlayBtns.push($currPlayBtn);
                            self.playBgRecord(path);
                        }
                    });
                }

                break;
                case 7://文件
                {
                    appcan.logs('reciveFileMgr======='+JSON.stringify(obj))
                    self.$el = $(chatFileLeftTemplate(obj));
                    if((self.model.get("dlstatus")) == 0){
                        appcan.button($(".xiazai",self.$el), "", function() {
                            uexIM.downloaderChatMgr(dparams);
                            event.stopPropagation();
                        });
                    }
                    appcan.button($(".fileMgr",self.$el), "", function(a) {
                        var path = this.id;
                        if (path== undefined) {
                        } else {
                            var cur = $(".xiazai",$(this));
                            if(cur[0] && cur.html().indexOf("下载完成")<0){
                                uexIM.downloaderChatMgr(dparams);
                                event.stopPropagation();
                                return;
                            }
                            uexDocumentReader.openDocumentReader(path);
                        }
                    });
                }
                break;
                default:
                break;
            }
        }
        }catch(e){
            alert(e.message+'---'+e.stack)
        }
        this.bindingEvents();

        return this;
    },
    change : function (s){//IM表情替换图片
        return '<img style="width:1.5em;height:1.5em;"  src="wgtResemojicons/'+biaoqing[s]+'" border="0" align="center">';
    },
    bindingEvents : function() {
        var self = this;
        $(".textType",self.$el).off('longTap').on('longTap', function() {
             var _this = this;
             var content = $(this).children().children().data("data");
             uexWindow.cbActionSheet = function(a, b, data) {
                switch(parseInt(data)) {
                case 0:
                   if (decodeURIComponent(content).indexOf("长按消息加入:") > -1) {
                            confirm2(function(i) {
                                if (i == 1) {

                                    var videoID = decodeURIComponent(content).split(':')[1];
                                    appcan.setLocVal("iscreater", videoID);
                                    appcan.window.openToast('加入视频会议中');
                                    appcan.setLocVal("loginingVidio", 1);
                                    appcan.window.publish('E_SFSP_INITLOGIN');
                                    appcan.locStorage.setVal("isGroupVidio",0);
                                }
                            }, '是否加入视频会议?')

                        } else {
                            uexClipboard.copy(decodeURIComponent(content));

                        }
                    break;
                }
            }
            if(decodeURIComponent(content).indexOf("长按消息加入:") > -1){
             var str = ["加入"];
             uexWindow.actionSheet("菜单", "取消", str);
            }else{
             var str = ["复制"];
             uexWindow.actionSheet("菜单", "取消", str);
            }

        });

        appcan.button($(".urlGO",self.$el), "", function(a) {
            var json = {name:$(this).text(),url:$(this).data("data"),"extraInfo":{"opaque":"true","bgColor":"#ecf3f7","delayTime":"250"}}
            appcan.setLocVal("CARD_PARAM",json);
            appcan.window.open("webWind","webWind.html",10)
        });
        appcan.button($(".pic",self.$el), "", function(a) {
            var array = [];
            var cure = $(".piclist",self.$el)[0];
            var url = cure.id || cure.src;
            var itemId = self.model.get("msgId") + "abc";
            if($(".percent",$(cure))[0] || ($(".huihuaunloadfail",$("#"+itemId))[0]&&!$(".huihuaunloadfail",$("#"+itemId)).hasClass("uhide"))){
                return;
            }
            //array[0] = url;
            var n = 0;
            var startIndex = 0;
            $('.piclist').each(function(index){
                var url1 = this.id || this.src;
                var msgid = $(this).data("msgid")
                if(!$(".huihuaunloadfail",$("#"+msgid))[0] || (!$(".percent",$(this))[0] && $(".huihuaunloadfail",$("#"+msgid)).hasClass("uhide"))){
                if(url == url1){
                    startIndex = n;
                }
                n++;
                array.push(url1);
                }
            })
            var param={
                startIndex:startIndex,
                data:array
            }
            param=JSON.stringify(param);
            appcan.logs(param)
            if (url == undefined) {
            } else {
                uexImage.openBrowser(param);
            }
        });
        appcan.button($(".huihuaunload",self.$el),"",function(){
            var msgId = self.model.get("msgId");
            var msgtype = self.model.get("msgType");
            appcan.setLocVal("failedId",msgId);
            appcan.setLocVal("failedType",msgtype);
            cbActionSheetRe();
            var str = ["重新发送"];
            uexWindow.actionSheet("菜单", "取消", str);
        });
        appcan.button($(".huihuaunloadfail",self.$el),"",function(){
            var msgSender = self.model.get("msgSender");
            var msgId = self.model.get("msgId");
            var dparam = {
                imId : msgSender,
                msgId : msgId
            }
            var dparams = JSON.stringify(dparam);
            uexWindow.cbActionSheet = function(a, b, data) {
            switch(parseInt(data)) {
                case 0:

                   uexIM.downloaderChatMgr(dparams);
                break;
               }
            }
            var str = ["重新加载"];
            uexWindow.actionSheet("菜单", "取消", str);
        });
        appcan.button($(".yuyinfail",self.$el),"",function(){
            var msgSender = self.model.get("msgSender");
            var msgId = self.model.get("msgId");
            var dparam = {
                imId : msgSender,
                msgId : msgId
            }
            var dparams = JSON.stringify(dparam);
            uexWindow.cbActionSheet = function(a, b, data) {
            switch(parseInt(data)) {
                case 0:
                   uexIM.downloaderChatMgr(dparams);
                break;
               }
            }
            var str = ["重新加载"];
            uexWindow.actionSheet("菜单", "取消", str);
        });

    },
    updateView : function(model) {
        var self = this;
        var chatType = Number(model.get("chatType"));
        var sendStatus = model.get("sendStatus");
        var msgId = model.get("msgId");
        if (sendStatus == 1) {//发送中
        } else if (sendStatus == 2) {//发送成功
           $("div.iconwhh1",self.$el).removeClass("huihuaunload1").removeClass("huihuaunload");
           $("#"+msgId+'_').css("opacity","1");
            var con = model.get("content");
            if(con.indexOf("location")==0){
                 lazyLoadImage(con.substring(8),self.$el,function(path,s){
                    var dom  = $(".mapUrl",s.dom)
                    dom.css("background-image", "url(file://" + path + ") !important")
                    dom.empty();
                })
            }
        } else if (sendStatus == 3) {//发送失败
           $("div.iconwhh1",self.$el).removeClass("huihuaunload1").addClass("huihuaunload");
        }
        appcan.button($(".huihuaunload",self.$el),"",function(){
            var msgId = self.model.get("msgId");
            var msgtype = self.model.get("msgType");
            appcan.setLocVal("failedId",msgId);
            appcan.setLocVal("failedType",msgtype);
            cbActionSheetRe();
            var str = ["重新发送"];
            uexWindow.actionSheet("菜单", "取消", str);
        });
    },
    conver : function() {

    },
    dateSet : function(d) {
        var time = NYR(d, 1);
        var nyr = NYR('', 1);
        if (time == nyr) {
            var cTime = HM(d);
        } else {
            var cTime = NYR(d, 0);
        }
        return cTime;
    },
    playBgRecord :function (recordPath) {//点击音频文件，播放录音
        var param = {
            playMode:0
        };
        param = JSON.stringify(param);
        uexAudio.setPlayMode(param);
        uexAudio.open(recordPath);
        uexAudio.setProximityState('1');
        uexAudio.play('0');
    }
});

//列表容器VIEW
var chatListView = Backbone.View.extend({//options...

    initialize : function() {
        var self = this;
        self.collection = new chatCollection();
        self.listenTo(self.collection, "add", self.add);
        self.listenTo(self.collection, 'sort', self.sort);
        self.listenTo(self.collection, "change", self.updateView);
        self.listenTo(self.collection, "remove", self.removeView);

    },
    //collection : new chatCollection(), //collection，用于存储和管理数据
    pageCount:15,
    el : '#huihuainfolist', //VIEW 对应 HTML 元素CSS选择器
    $currPlayBtns : [],
    handlePlayEnd : function(){
        var _hanlder = function($currPlayBtn){
            if($currPlayBtn.hasClass('yuyin2Gif')){
                $currPlayBtn.removeClass('yuyin2Gif').addClass('yuyin2');
            }else if($currPlayBtn.hasClass('yuyinGif')){
                $currPlayBtn.removeClass('yuyinGif').addClass('yuyin');
            }
        };
        var length = this.$currPlayBtns.length;
        if(length == 1){
            _hanlder(this.$currPlayBtns[0]);
            this.$currPlayBtns = [];
        }else{
           this.$currPlayBtns.forEach(function($currPlayBtn,index){
               if(index < length - 1){
                   _hanlder($currPlayBtn);
               }
           });
           this.$currPlayBtns.splice(0,length-1);
        }
    },
    getChatList : function(t) {//HTML页面调用的初始化接口，由于通讯有可能依赖APPCAN组件，因此封装此接口在appcan.ready中调用
        var self = this;
        appcan.setLocVal("upAndDown",t);

        var listObj = {
            imId : self.chatId,
            msgCount : self.pageCount
         }
         if(t==0){
           listObj.startTime = self.chatTime;
        }
        this.collection.fetch({
            channel:"E_XMPP_GETCHATLIST",
            param:listObj,
            t:t,
            success : function(cols, resp, options) {
                 appcan.logs("E_XMPP_GETCHATLIST rsp:"+resp);
               appcan.logs("E_XMPP_GETCHATLIST rsp:"+JSON.stringify(resp));
               try{
                if(t==1){
                    var data = resp[0];
                    self.chatTime = data.timestamp;
                    //self.toDown();
                }else{
                    var data = resp[resp.length-1];
                    self.chatTime = data.timestamp;
                }
                }catch(e){
                 appcan.logs("e:"+e);
               }
            },
            error : function(cols, error, options) {
               // appcan.frame.resetBounce(t);
            },
            add:true,
            remove:t?true:false,
            merge:true,
            pre:t?false:true,
            t:t
        });
    },
    sendMsg:function(msg, channel){
        var self = this;
        if(channel=="E_XMPP_SENDMSGTEXT"){
            appcan.window.publishForJson(channel, msg);
        }else{
            appcan.window.publish(channel, msg);
        }
    },
    newEl:$("<div></div>"),
    add : function(model,res,op) {
        try {
            var itemTime = model.get("timestamp") || Date.now();
            model.set("timestamp",itemTime)
            if(!op.pre){
                this.setTimeShow(itemTime,this.$el);
            }
            var view = new chatView({
                model : model
            });
            view.baseView = this;
            if(!op.pre){
                this.$el.append(view.$el);
                if(op.t && op.t==1){
                   window.scrollTo(0, document.body.scrollHeight);
                }else{
                    this.toDown();
                }
            }else{
                this.newEl.prepend(view.$el);
                var total = res.toJSON();
                if(total[total.length-1].msgId == model.get("msgId")){
                   this.$el.prepend(this.setFormTime(itemTime));
                   var tempEl = $("<div></div>")
                   tempEl.insertAfter(this.$el.children().first());
                   tempEl.html(this.newEl)
                   $("<div id='__"+model.get("msgId")+"'></div>").insertAfter(tempEl);
                   location.href = "#__"+model.get("msgId")
                   this.newEl = $("<div></div>");
                }
            }

        } catch(e) {
            alert(e.message);
        }
    },
    updateView : function(model) {
       appcan.logs('updateView-----' + JSON.stringify(model.toJSON()))
        var view = model.view;
        if (view) {
            //this.$el.prepend(view.$el);
            view.updateView(model);
            appcan.logs('updateView-----')
        }
    },
    removeView : function(model) {
        var view = model.view;
        view.remove();
    },
    getElementHeight : function (){
        var retHeight = 0;
        var eles = document.getElementById('huihuainfolist') && document.getElementById('huihuainfolist').children;
        if(eles && eles.length>0){
            for(var i =0;i<eles.length;i++){
                retHeight += eles[i].offsetHeight;
            }
        }else{
            retHeight = document.getElementById('huihuainfolist').offsetHeight
        }
        return retHeight;
    },
    toDown : function (){//发送成功页面滚到最底部
        if(isAndroid){
           window.scrollTo(0, document.body.scrollHeight);
        }else{
            var heightFrame = chatListViewInstance.getElementHeight()+10;
             uexChatKeyboard.changeWebViewFrame(heightFrame);
        }
    },
    setTimeShow : function (thisTime,dom){
        var self = this;
        var last = dom.children().last();
        if(last[0]){
            var lastTime = last.data("time");
            var at = Math.abs(thisTime - lastTime)-60*10*1000;
            if(at>0){
               return dom.append(self.setFormTime(thisTime));
            }else{
                return '';
            }
            return;
        }else{
           return dom.append(self.setFormTime(thisTime));
        }
    },
    setFormTime : function (t){
        var nowTime = new Date();
        var compareTime = new Date(t);
        var days=Math.floor((nowTime.getTime()-t)/(24*3600*1000));
        if(days>1){
            var tStr = NYR(t,1);
        }else{
           if(nowTime.getDate()-compareTime.getDate()==0){
               var tStr = HM(t);
           }else{
               var tStr = "昨日"+HM(t);
           }
        }
        var str =  '<div class="ub-f1"><div class=" ub  ub-pc ub-ac"><div style="font-size:0.6em;background:#ccc;padding:0.4em;border-radius:3px;color:#fff">'+tStr+'</div></div></div>';
        return str;
    },
    sendMsgDeal : function(data){
         appcan.logs("sendMsgDeal----"+JSON.stringify(data));
        var self = this;
        var length = self.msgArr.length;
        if(length>0){
            var msg = '';
            var n = 0;
            var isChange = 0;
            for(var i=0;i<length;i++){
                var msg1 = self.msgArr[i];
                if(msg1.msgId && msg1.msgId==data.msgId){
                    msg = msg1;
                    n = i;
                    isChange = 1;
                    break;
                }
            }
            if(!isChange){
                for(var i=0;i<length;i++){
                    var msg1 = self.msgArr[i];
                    if(!msg1.msgId){
                        msg1.msgId = data.msgId;
                        n = i;
                        msg = msg1;
                        break;
                    }
                }

            }
            if(msg.sendStatus==2 && data.status==1){
                appcan.logs("sendStatus-already2");
                return
            }
            msg.sendStatus = data.status;
            msg.status = data.status;
            msg.isSend = 1;
            msg.msgSender = appcan.getLocVal("userIdIm").toLowerCase();
            self.collection.push(msg,{add:true,remove:false,merge:true,pre:false})
            self.msgArr.splice(n,1);
            if(msg.sendStatus==1){
                self.msgArr.unshift(msg);
            }
            //self.toDown();

        }
    }
});

var chatListViewInstance = new chatListView();

chatListViewInstance.path = '';
chatListViewInstance.audioTime = 0;
chatListViewInstance.msgArr = [];
chatListViewInstance.voiceFlag = 1;//录音标记
chatListViewInstance.chatTime = getTime();

//聊天人的信息
chatListViewInstance.chatIcon = appcan.getLocVal(storeKey.CONTACT_ICON);
chatListViewInstance.chatId = appcan.getLocVal(storeKey.PERSON_ID).toLowerCase();
chatListViewInstance.chatName = appcan.getLocVal(storeKey.CONTACT_NAME);
appcan.logs("-聊天人chatId-" + chatListViewInstance.chatId)
var userData = JSON.parse(encryptDecode(appcan.locStorage.getVal('userData')))
var perInfo = appcan.getLocVal(storeKey.PERSON_INFO);
var headurl ='';
if(isDefine(userData.user_name)){
 var perInfoFullName =userData.user_name
}else{
    var perInfoFullName =userData.userid
}
if(isDefine(userData.pic_url)){
     if (isDefine(userData.businesstype)) {
        headurl = picture_url + '/' + userData.pic_url.replace(/\\/g, '/') + '/' + userData.pic_name
     }else{
     headurl = server_url + '/' + userData.pic_url.replace(/\\/g, '/') + '/' + userData.pic_name
     }

}
if (isDefine(userData)){
    chatListViewInstance.selfIcon = headurl//JSON.parse(perInfo).userIcon;
    chatListViewInstance.selfName = perInfoFullName//JSON.parse(perInfo).fullName;
}else{
   // var   userData=  encryptDecode(appcan.locStorage.getVal('userData'));
    //     userData  = JSON.parse(userData);
    //     if(isDefine(userData && userData.pic_url)){
     //    var headurl = server_url +'/'+ userData.pic_url +'/'+ userData.pic_name
   // var indexInfo = JSON.parse(appcan.getLocVal("EMM_USER_INFO"));
//   chatListViewInstance.selfIcon = indexInfo.loginUser.entity.userIcon;
    chatListViewInstance.selfName ='用户'
     chatListViewInstance.selfIcon = ''
}

function lazyLoadImage(url, dom, sus) {
    if(window.lazyICache)
    {
       window.lazyICache.run({url:url,success:(sus?sus:''),dom:dom});
    }
}
function setChatIcon(chatIcon,instance,type){
    if(isDefine(chatIcon))
    lazyLoadImage(constant.IMG_URL + chatIcon,null,function(p){
        if(instance){
            $('.'+type).each(function(index){
              if($(this).css("background-image").indexOf(p)<0){
                  $(this).css("background-image", "url(file://" + p + ") !important")
              }
              $(this).empty();
            })
            instance[type] = p;
        }
    })
}
appcan.ready(function() {
    appcan.window.publish("isGroup", '0');
    if(!window.lazyICache)
    {
        window.lazyICache = appcan.icache({maxtask:3});
    }
    setChatIcon(chatListViewInstance.selfIcon,chatListViewInstance,"selfIcon");
    setChatIcon(chatListViewInstance.chatIcon,chatListViewInstance,"chatIcon");
    appcan.initBounce();
    try{
    var param = {isSupport:true};
    uexWindow.setIsSupportSlideCallback(JSON.stringify(param));
    }catch(e){}
    getRealPath(function(p){
        appcan.logs("getRealPath"+p);
        chatListViewInstance.path = p;
    chatListViewInstance.getChatList(1);
    })
    uexWindow.onSlipedUpEdge = function(){
        chatListViewInstance.getChatList(0);
    }
    // appcan.frame.setBounce([0], null, null, function(type) {
        // chatListViewInstance.getChatList(type);
    // });
    uexAudio.onPlayFinished=function(loopTime){
        chatListViewInstance.handlePlayEnd();
        uexAudio.setProximityState('0');
    }

    if (isAndroid) {
        var json = {
            "emojicons": "res://emojicons/emojicons.xml",
            "shares": "res://shares/shareschat.xml",
            "textColor": "#FFF",
            "textSize": "15.5"
        }
    }else{
        var json = {
            "emojicons": "res://emojicons/emojicons.xml",
            "shares": "res://shares/shareschat_ios.xml",
            "textColor": "#FFF",
            "textSize": "15.5"
        }
    };
    uexImage.onBrowserClosed=function(){
        if(uexWindow.showStatusBar) uexWindow.showStatusBar();
   }
    uexChatKeyboard.open(JSON.stringify(json));
    uexChatKeyboard.onKeyBoardShow = function(json){
        appcan.logs("onKeyBoardShow:"+json);
        var data = JSON.parse(json);
        if(data.status == 1){//键盘弹出状态
            if(isAndroid){
                appcan.logs("android");
                appcan.window.evaluateScript("","resizeWin()");
                //window.scrollTo(0, document.body.scrollHeight);
            }else{
                var heightFrame = chatListViewInstance.getElementHeight()+10;
                appcan.logs("IOS"+heightFrame);
                uexChatKeyboard.changeWebViewFrame(heightFrame);
            }
        }else{
            if(isAndroid){
                window.scrollTo(0, document.body.scrollHeight);
            }else{
                var heightFrame = chatListViewInstance.getElementHeight()+10;
                appcan.logs("IOS"+heightFrame);
                uexChatKeyboard.changeWebViewFrame(heightFrame);
            }
        }
    }
    appcan.window.subscribe("resize_win", function(result) {
        window.scrollTo(0, document.body.scrollHeight);
    });
    //监听到关闭页面后,关闭键盘
    appcan.window.subscribe("DANLIAO_KUANG", function(result) {
        appcan.logs("关闭下键盘");
        uexChatKeyboard.close();
        uexAudio.stop();
        appcan.window.publish("E_CTSP_REMOVEMEMBER", "remove_all_close");
        //appcan.window.evaluateScript("","closeWindow()")

    });
    //停止后台录音的回调方法
    uexAudio.cbBackgroundRecord = function(opCode, dataType, data) {
        chatListViewInstance.audioTime = parseInt(chatListViewInstance.audioTime);
        var voice = {
            imId : chatListViewInstance.chatId,
            voiceUrl : data,
            voiceTime : chatListViewInstance.audioTime
        }
        if (chatListViewInstance.audioTime == 0 || chatListViewInstance.voiceFlag == 0 || chatListViewInstance.audioTime > 60 ) {
        return;
        } else {
            chatListViewInstance.msgArr.unshift({
                voiceTime : chatListViewInstance.audioTime,
                resPath : data,
                msgType : 3,
            });
            chatListViewInstance.sendMsg(voice,"E_XMPP_SENDMSGVOICE")
        }
    }
    //录音监听
    uexChatKeyboard.onVoiceAction = function(data) {
        var data = JSON.parse(data);
        //0-开始录音，1-录音完成，-1-取消录音,//表示录音时间到达60s
        if (data.status == 0) {
           chatListViewInstance.voiceFlag = 0;
            chatListViewInstance.audioTime = (new Date).getTime();
            uexAudio.startBackgroundRecord(0, chatListViewInstance.audioTime+'');
        } else if (data.status == 1) {
            if(chatListViewInstance.voiceFlag == 0){
                chatListViewInstance.voiceFlag = 1;
                chatListViewInstance.audioTime = ((new Date).getTime() - chatListViewInstance.audioTime)/1000;
                //停止后台录音
                uexAudio.stopBackgroundRecord();
            }
        } else if (data.status == 2) {
            if(chatListViewInstance.voiceFlag == 0){
                chatListViewInstance.voiceFlag = 1;
                chatListViewInstance.audioTime = 60;
                //表示录音时间到达60s
                uexAudio.stopBackgroundRecord();
             }
        } else if (data.status == -1) {
            //取消录音--
            chatListViewInstance.audioTime = 0;
            uexAudio.stopBackgroundRecord();
        }
    }
    uexChatKeyboard.onCommitJson = function(msg) {//发送文本内容时的的监听状态,成功失败
        var msg1 = msg.emojiconsText;
        var msg2 = msg1.trim();
        if(msg2 == ''){
            appcan.window.openToast("不能发送空格", 1500, 5);
        }else{
            var text = {
                imId : chatListViewInstance.chatId,
                content : msg1,
                chatName : chatListViewInstance.chatName
            }
            chatListViewInstance.msgArr.unshift({
                content : msg1,
                msgType : 1
            });
            chatListViewInstance.sendMsg(text,"E_XMPP_SENDMSGTEXT")
        }
    }
    function sendFile(fileUrl){
        //var fileObj = JSON.stringify(json);
        var file = {
            imId : chatListViewInstance.chatId,
            fileUrl: fileUrl
        }
        //alert(JSON.stringify(file));
        chatListViewInstance.msgArr.unshift({
            resPath : fileUrl,
            msgType : 7
        });
        uexChatKeyboard.hideKeyboard();
        chatListViewInstance.sendMsg(file,"E_XMPP_SENDMSGFILE")
    }
    //从相册中选图回调
    function cbPick(data) {
        var data = JSON.parse(data);
        if(data.isCancelled == false){
            for(var i = data.data.length-1;i>=0;i--){
                var imgurl = data.data[i];
                var picture = {
                    imId : chatListViewInstance.chatId,
                    imageUrl : imgurl,
                    chatName : chatListViewInstance.chatName
                }
                chatListViewInstance.msgArr.unshift({
                    resPath : imgurl,
                    msgType : 2
                });
                uexChatKeyboard.hideKeyboard();
                chatListViewInstance.sendMsg(picture,"E_XMPP_SENDMSGPICTURE")
            }
        }
        if(uexWindow.showStatusBar) uexWindow.showStatusBar();
    }

    //相机 回调方法
    function cbOpen(opId, dataType, data) {
        console.log("cnOpen---:"+data);
        appcan.logs("cnOpen---:"+data);
        var imgurl = data;
        var picture = {
            imId : chatListViewInstance.chatId,
            imageUrl : imgurl,
            chatName : chatListViewInstance.chatName
        }
        chatListViewInstance.msgArr.unshift({
            resPath : imgurl,
            msgType : 2
        });
        uexChatKeyboard.hideKeyboard();
        console.log("cnOpen1---:"+data);
        appcan.logs("cnOpen1---:"+data);
        chatListViewInstance.sendMsg(picture,"E_XMPP_SENDMSGPICTURE")
    }
    //uexChatKeyboard监听是选择的相册还是拍摄
    uexChatKeyboard.onShareMenuItem = function(index) {
        if (index == 0) {//拍摄
            uexCamera.cbOpen = cbOpen;
            uexCamera.open(0,50);
        } else if (index == 1) {//照片
        //从相册中选择图片
            uexImage.onPickerClosed = cbPick;
            var sData = {
                min:1,
                max:6
            }
            var json = JSON.stringify(sData);
            uexImage.openPicker(json);
        }else if (index == 2) { //视频
                appcan.window.openToast('创建视频会议中');
                uexYunTongXunIM.endVideoConf();
                appcan.setLocVal("iscreater", 1);
                appcan.setLocVal("loginingVidio", 1);
                appcan.window.publish('E_SFSP_INITLOGIN');
                appcan.locStorage.setVal("isGroupVidio",0);


            }else if (index == 3) { //12348
                            try {
                 uexCall.dial('12348')
            } catch(e) {
                appcan.window.alert({
                    title : '提示',
                    content : '当前设备不支持呼叫',
                    buttons : '确定'
                });
            }
            }
             //  else if (index == 3) {//文件
        //     if(isAndroid){
        //         uexFileMgr.cbExplorer = function(opId,dataType,dataPath){
        //             sendFile(dataPath);
        //         }
        //         uexFileMgr.explorer('');
        //     }
        // }
    }

   //开启键盘
        appcan.window.subscribe("E_CTSP_OPENKEYBOR", function() {
        if (isAndroid) {
        var json = {
            "emojicons": "res://emojicons/emojicons.xml",
            "shares": "res://shares/shareschat.xml",
            "textColor": "#FFF",
            "textSize": "15.5"
        }
    }else{
        var json = {
            "emojicons": "res://emojicons/emojicons.xml",
            "shares": "res://shares/shareschat_ios.xml",
            "textColor": "#FFF",
            "textSize": "15.5"
        }
    };
    uexImage.onBrowserClosed = function() {
        if (uexWindow.showStatusBar) uexWindow.showStatusBar();
    }
    uexChatKeyboard.open(JSON.stringify(json));

    });
        //创建视频会议
    appcan.window.subscribe("E_CTSP_CREATEMET", function() {
members = {
        1: false,
        2: false
    }
         appcan.logs("E_CTSP_CREATEMET---1");
        var creater = appcan.getLocVal("iscreater");
        appcan.window.closeToast();
        uexChatKeyboard.close();
        // try{
        // uexAudio.stop();
        // }catch(e){}

        appcan.window.evaluateScript("", "enterVideo()");
        if (creater == 1) {

            var videoRooms = { "videoName": "视频", "videoSound": "3", "videoDelete": "1", "videoClose": "1", "videoJoin": "1", "videoSquare": "3" };
            appcan.logs("createChatVideoRoom-CHAT-"+JSON.stringify(videoRooms));
            uexYunTongXunIM.createChatVideoRoom(JSON.stringify(videoRooms));
        } else {
            var joinJsonID = { "videoRoomID": creater+"" };
            appcan.logs("joinVideoMeeting-CHAT--"+JSON.stringify(joinJsonID));
            uexYunTongXunIM.joinVideoMeeting(JSON.stringify(joinJsonID))
        }
appcan.logs("E_CTSP_CREATEMET--CHAT-3");
    });

    //监听创建视频会议
    appcan.window.subscribe("E_CTSP_CREATEMEETING", function(param) {
        if (param.state == 200) {

            var data = param;
            var msg1 = '我已经开启了法律服务咨询视频，请您长按消息加入:' + data.meetingNumber
            var text = {
                imId : chatListViewInstance.chatId,
                content : msg1,
                chatName : chatListViewInstance.chatName
            }
            chatListViewInstance.msgArr.unshift({
                content : msg1,
                msgType : 1
            });
            chatListViewInstance.sendMsg(text, "E_XMPP_SENDMSGTEXT")

        }
        //chatListViewInstance.add(param);
    });
    //创建本地视频图像
    appcan.window.subscribe("E_CTSP_ADDME", function() {
        var param = {
            top: 0,
            left: 0,
            width: window.screen.width / 2,
            height: window.screen.height / 3
        };
         appcan.logs("E_CTSP_ADDME---" + JSON.stringify(param));
        uexYunTongXunIM.addMeetingVideoLocalView(JSON.stringify(param));

    });
    //移除成员视频图像
    appcan.window.subscribe("E_CTSP_REMOVEMEMBER", function(param) {
        if(param =='remove_all'){
        uexYunTongXunIM.removeMeetingVideoLocalView();
           for (var i in members) {
            if(members[i]){


         var json = {
            member:members[i]+''
        };
         appcan.logs("REMOVEMEMBER---" + JSON.stringify(json));
               uexYunTongXunIM.removeMeetingVideoMemberView(JSON.stringify(json));
               members[i] = false;
            }
         }
         uexYunTongXunIM.endVideoConf();
         uexYunTongXunIM.logout();
        }else if(param =='remove_all_close'){
          uexYunTongXunIM.removeMeetingVideoLocalView();
           for (var i in members) {
            if(members[i]){
         var json = {
            member:members[i]+''
        };
         appcan.logs("REMOVEMEMBER---" + JSON.stringify(json));
               uexYunTongXunIM.removeMeetingVideoMemberView(JSON.stringify(json));
               members[i] = false;
            }
         }
         uexYunTongXunIM.endVideoConf();
         uexYunTongXunIM.logout();
            appcan.window.evaluateScript("","closeWindow()")
        }else{
         for (var i in members) {
            if(members[i] == param){
               members[i] = false;
        appcan.logs("members[-"+i+"--" + members[i]);

            }
         }

       var json = {
            member:param+''
        };
          appcan.logs("REMOVEMEMBER---" + JSON.stringify(json));
               uexYunTongXunIM.removeMeetingVideoMemberView(JSON.stringify(json));
         }
    });
    appcan.window.subscribe("E_CTSP_SWITCHCAMERA", function(param) {
        appcan.logs("E_CTSP_SWITCHCAMERA---" + param);
        uexYunTongXunIM.changeCam(param);
    });
    appcan.window.subscribe("E_CTSP_VOICEMUTE", function(param) {
         appcan.logs("E_CTSP_VOICEMUTE---" + param);
        uexYunTongXunIM.voiceMute(param)
    });
    appcan.window.subscribe("E_CTSP_HANDFREE", function(param) {
         appcan.logs("E_CTSP_HANDFREE---" + param);
        uexYunTongXunIM.voiceHandFree(param)
    });
    //创建群成员视频图像
    var members = {
        1: false
    //    2: false
    }
    appcan.window.subscribe("E_CTSP_ADDMEMBER", function(param) {
         //    for (var i in members) {
         //    if(members[i] == param){
         //       members[i] = false;
         // appcan.logs("REMOVEMEMBER---" + param);
         //       uexYunTongXunIM.removeMeetingVideoMemberView(param);
         //    }
         // }
        if (!members[1]) {
            var Json = JSON.stringify({
                member: param+'',
                top: 0,
                left: window.screen.width / 2,
                width: window.screen.width / 2,
                height: window.screen.height / 3
            });
            members[1] = param
             appcan.logs("ADDMEMBER-CT--1" + Json);
            uexYunTongXunIM.addMeetingVideoMemberView(Json);
        }
        //  else if (!members[2]) {
        //     var Json = JSON.stringify({
        //         member: param+'',
        //         top: window.screen.height / 3,
        //         left: window.screen.width / 4,
        //         width: window.screen.width / 2,
        //         height: window.screen.height / 3
        //     });
        //     members[2] = param
        //     appcan.logs("ADDMEMBER---2" + Json);
        //     uexYunTongXunIM.addMeetingVideoMemberView(Json);
        // }
        // else{
        //                     var param = {
        //                             member : param+''
        //                         };
        //                         appcan.logs("---publish REMOVEMEMBERBYkICK--" + JSON.stringify(param))
        //                         appcan.window.publish("E_SFSP_REMOVEMEMBER", JSON.stringify(param));
        //         var Json = JSON.stringify({
        //         member: param+'',
        //         top: 0,
        //         left: window.screen.width / 2,
        //         width: window.screen.width / 2,
        //         height: window.screen.height / 3
        //     });
        //     members[1] = param
        //      appcan.logs("ADDMEMBER---11" + Json);
        //     uexYunTongXunIM.addMeetingVideoMemberView(Json);
        // }


    });
    //监听发送状态
    appcan.window.subscribe("E_XMPP_GETSENDSTATUS", function(param) {
        appcan.logs("E_XMPP_GETSENDSTATUS----"+JSON.stringify(param));
        chatListViewInstance.sendMsgDeal(param);
    });
    //监听到新消息来了
    appcan.window.subscribe("E_XMPP_NEWMSGCOMING", function(param) {
        if(param.msgSender==chatListViewInstance.chatId){
            var data = param;
            data.isSend = 0;
            data.dlstatus = data.dlStatus || data.dlstatus;
            chatListViewInstance.collection.push( data, {add:true,remove:false,merge:true,pre:false})
            var params={
            imId:data.msgSender,
            type:"all"
            }
            var params1=JSON.stringify(params)
            uexIM.setMarkMsgRead(params1);
            uexIM.getUserAndGroupAllMsgUnreadCount();

             if (data.content.indexOf("长按消息加入:") > -1) {
                confirm2(function(i) {
                    if (i == 1) {

                        var videoID = data.content.split(':')[1];
                        appcan.setLocVal("iscreater", videoID);
                        appcan.window.openToast('加入视频会议中');
                        appcan.setLocVal("loginingVidio", 1);
                        appcan.window.publish('E_SFSP_INITLOGIN');
                        appcan.locStorage.setVal("isGroupVidio",0);
                    }
                }, '是否加入视频会议?')

            }
        }
        //chatListViewInstance.add(param);
    });





    //下载图片和语音的回调
    appcan.window.subscribe("DOWN_IMG_VOICE", function(result) {
        appcan.logs("DOWN_IMG_VOICE----"+result);
        //var data = JSON.parse(result);
        var data = result;
        var status = data.dlstatus;
        var msgType = data.msgType;
        var percent = data.percent;//百分比
        var msgId = data.msgId;
        var resPath = data.resPath;
        switch (parseInt(status)){
            case 1:
                //下载中
                if(msgType==3){
                   //$("#"+msgId).children().eq(1).html(percent+"%");
                }else if(msgType==2){
                    $(".percent",$("#"+msgId)).html(percent+"%");
                }else if(msgType==7){
                    $("#"+msgId+'abc').find("div.dlSta").html(percent+"%");
                };
            break;
            case 2:
                //下载成功
                if(msgType==3){
                   // $("#"+msgId).children().eq(1).html("");
                   $("#"+msgId).find("div.uhide").html(resPath);
                   $("#"+msgId+'_').find("div.uhide").html(resPath);
                   $("#"+msgId+'_').css("opacity","1");
                   $(".abcd",$("#"+msgId+'abc')).addClass("uhide");
                }else if(msgType==2){
                    $("#"+msgId+'_').html("");
                    $("#"+msgId+'_').css("opacity","1");
                    $("#"+msgId+'_').css("background-image","url('"+resPath+"')!important");
                    $(".abcd",$("#"+msgId+'abc')).addClass("uhide");
                    $("#"+msgId+'abc').find("div.piclist").attr("id",resPath);
                }else if(msgType==7){
                    $("#"+msgId+'abc').find("div.dlSta").html("下载完成");
                    $("#"+msgId+'abc').find("div.fileMgr").attr("id",resPath);
                    $("#"+msgId+'abc').find("div.xiazai").removeClass("xiazai");
                };

            break;
            case 3:
                //下载失败
                 var msgId = data.msgId;
                if(msgType==2){
                    $("#"+msgId+'_').children().remove();
                    $(".iconwhh1",$("#"+msgId+'abc')).removeClass("uhide").removeClass("huihuaunload1").addClass("huihuaunload");
                }else if(msgType==3){
                    $(".iconwhh1",$("#"+msgId+'abc')).removeClass("uhide").removeClass("huihuaunload1").addClass("huihuaunload");
                }else if(msgType==7){
                    $("#"+msgId+'abc').find("div.dlSta").html("下载失败");
                };
            break;
        }
    })
})

function cbActionSheetRe(){
    uexWindow.cbActionSheet = function(a, b, data) {
        switch(parseInt(data)) {
        case 0:
             var failedId = appcan.getLocVal("failedId");
             var failedType = appcan.getLocVal("failedType");
             var textContent = decodeURIComponent($("#"+failedId+"abc").find("span").data("data"));
             var picUrl = $("#"+failedId+"abc").find("div.piclist").attr("id");
             var voiceUrl = $("#"+failedId+"abc").find("div.nnn").html();
             var fileUrl = $("#"+failedId+"abc").find("div.fileMgr").attr("id");
             var voiceTime = $("#"+failedId+"abc").find("div.baseWhite").html();
             //$("#"+failedId+"abc").remove();
             //chatListViewInstance.collection.get(failedId).view.remove();
             if(failedType == "1" || failedType == "text"){
                var text = {
                    msgId : failedId,
                    imId : chatListViewInstance.chatId,
                    content : textContent,
                    chatName : chatListViewInstance.chatName
                }
                chatListViewInstance.msgArr.unshift({
                    content : textContent,
                    type : 1
                });
                 chatListViewInstance.sendMsg(text,"E_XMPP_SENDMSGTEXT")
             }else if(failedType == "2" || failedType == "picture"){
                var picture = {
                    msgId : failedId,
                    imId : chatListViewInstance.chatId,
                    imageUrl : picUrl,
                    chatName : chatListViewInstance.chatName
                }
                chatListViewInstance.msgArr.unshift({
                    resPath : picUrl,
                    type : 2
                });
                chatListViewInstance.sendMsg(picture,"E_XMPP_SENDMSGPICTURE")
             }else if(failedType == "3" || failedType == "voice"){
                 var voice = {
                      msgId : failedId,
                      imId : chatListViewInstance.chatId,
                      voiceUrl : voiceUrl,
                      voiceTime : voiceTime
                  }
                 if (voiceTime == 0) {
                 return;
                 } else {
                 chatListViewInstance.msgArr.unshift({
                     voiceTime : voiceTime,
                     resPath : voiceUrl,
                     type : 3
                 });
                chatListViewInstance.sendMsg(voice,"E_XMPP_SENDMSGVOICE")
                }
             }else if(failedType == "7" || failedType == "file"){
                 var file = {
                      msgId : failedId,
                      imId : chatListViewInstance.chatId,
                      fileUrl: fileUrl
                  };
                 chatListViewInstance.msgArr.unshift({
                     resPath : fileUrl,
                     type : 7
                 });
                chatListViewInstance.sendMsg(file,"E_XMPP_SENDMSGFILE");
             };
            break;
        }
     }
}
