var qunliaoChengyuanTemplate = loadTemplate("assets/templates/qunliaoChengyuan.tpl");
var applistData = [];
var qunliaoChengyuanView = Backbone.View.extend({
    initialize : function(){
        this.model.view = this;
        this.render();
    },
    template : qunliaoChengyuanTemplate,
    dealIcon : function(icon){
        if (icon)
            return 'lazy" data-original="' + constant.IMG_URL + icon;
        return "";
    },
    render : function(){
        var self = this;
        //alert(this.model.attributes.msg.JSON.stringify());
        if(this.template){
            this.$el = this.template({
                    data:this.model.attributes,
                    dealIcon : self.dealIcon
                });
        };
        var appData = {
                content : this.$el,
                hideOption : {//switch
                    content : '<div class="uinn2">删除</div>',
                    style :{
                        fontSize : "1em",
                        background : "red"
                    },
                    onClick:function(e,index,length){
                        var userId = ($("#del"+index).children()[0].id);
                        appcan.setLocVal("delUserid",userId);
                        var loginId = (appcan.getLocVal("userIdIm"));
                        //1是管理员 0不是管理员
                        var admin = Number(appcan.getLocVal("admin"));
                        if(admin == 1){
                            if(userId == loginId){
                               appcan.window.openToast("创建人不能进行此操作",2000,5);
                            }else{
                                //将某人剔除群
                                var groupName = appcan.getLocVal("qunId");
                               // var imId = appcan.getLocVal("imId0");
                                var param = {
                                    groupName:groupName,
                                    imId:userId.toLowerCase(),
                                    reason:""
                                };
                                var params = JSON.stringify(param);
                                uexIM.kickFromChatGroup(params);
                            }
                        }else{
                            appcan.window.openToast("您还不是管理员",2000,5);
                        }
                    }
                }
             };
             applistData.push(appData);

            return this;
    }
})

var qunliaoListView = Backbone.View.extend({
    initialize : function(){
        this.listenTo(this.collection,"add",this.addView);
    },
    collection : new chengyuanList(),
    el:"#list",
    load : function(t){
        applistData = [];
        var self = this;
        self.pageNo = 1;
        self.groupObjIds = appcan.getLocVal("groupObjIds");
        appcan.window.openToast("正在加载");
        var perArr = JSON.parse(appcan.getLocVal("personId"));
        var relation = [];
        for(var j=0;j<perArr.length;j++){
            var userid = perArr[j];
            var obj = {
                userId :userid
            }
            relation.push(obj);
        };
        this.collection.fetch({
            success : function(data,resp,option){
                appcan.frame.resetBounce(t);
                appcan.window.closeToast();
                lv = appcan.optionList({
                        selector : "#list",
                        type : "hiddenLine",
                        duration :"500ms",
                        multiShow : false,
                        align : 'left'
                    });
                    lv.set(applistData);
               setTimeout(function(){
                   $("div.lazy").lazyload({
                    cache:true
                });
               },1000)
            },
            error : function(err,resp,option){
                appcan.frame.resetBounce(t);
                appcan.window.closeToast();
                switch(error.status) {
                default:
                    global_error(error);
                    break;
                }
            },
            idArr : relation,
            type : t
        })
    },
    addView : function(model){
        var view = new qunliaoChengyuanView({
            model : model
        });
    }
})

var qunliaoListViewInstance = new qunliaoListView();
