var loginView = Backbone.View.extend({//options...
    initialize : function() {
        this.stickit();
        var self = this;
        appcan.button("#btn", "btn-act", function() {
            self.$el.submit();
        })
        appcan.button(".pswCheck", "btn-act", function() {
            var isTure = $(".check2").hasClass("uhide");
            if (isTure) {
                $(".check2").removeClass("uhide");
                $(".check1").addClass("uhide");
            } else {
                $(".check1").removeClass("uhide");
                $(".check2").addClass("uhide");
            }
        })
        
        // $("#username").onchange=function(){
            // this.model.set("loginPass","");
        // }
    },

    model : new loginModel(),
    el : 'form',
    events : {
        'submit' : 'submitLogin',
    },
    bindings : {
        "#username" : {
            observe : 'loginName',
            updateModel : 'validUname',
            onGet:function(v){
                var loginName = v;
                if (!isSaas && v && mailSuffix) {
                    var loginName = v.substring(0, v.indexOf('@'));
                    return loginName;
                }
                return loginName;
                
            },onSet:function(v){
                if(!isSaas && v && mailSuffix && v.indexOf("@")>0){
                    var name = v.substring(0, v.indexOf('@'));
                    return name;
                }
                return v;
            }
        },
        "#password" : "loginPass",
        "#domainName" : {
            observe : "domainName",
        }
    },
    validUname : function(val, event, options) {
        return true;
    },
    lock : false,
    submitLogin : function() {
        if (!this.model.isValid()) {
             appcan.window.openToast(this.model.validationError,1500,5);
            return false;
        }
        
        var self = this;
        if(self.lock){
            return false;
        }
        self.lock = true;
        $("#username")[0].blur();
        $("#password")[0].blur();
        this.model.set("loginName",loginNameSub(this.model.get("loginName")));
        appcan.window.openToast('登录中');
        this.model.save({}, {
            success : function(model, resp, options) {
                self.lock = false;
                appcan.window.closeToast();
                appcan.setLocVal("EMM_USER_INFO",resp);
                appcan.window.publish("IM-LOGIN","");
                appcan.window.publish("loginoutSucc",'') 
            },
            error : function(model, error, options) {
                self.lock = false;
               appcan.window.closeToast();
               switch(error.status)
                {
                    default:
                    global_error(error);
                    break;
                }
               
            }
        });
        return false;
    }
});

var loginViewInstance = new loginView();
appcan.ready(function() {
   // initEmmApp();
   appcan.window.subscribe("indexClose",function(a){
       loginViewInstance.model.set("loginPass","");
    });
    document.documentElement.style.webkitTouchCallout = 'none';
    //监听返回键
    uexWindow.onKeyPressed = function(keyCode) {
        if (keyCode == '0') {
            
        }
    }
    uexWindow.setReportKey('0', '1');
    var psw = loginViewInstance.model.get("loginPass");
    if(psw && !$(".check2").hasClass("uhide")){
         loginViewInstance.submitLogin();
    }
});