var chatGroupAddModel = Backbone.Model.extend({
    initialize : function() {
        this.set({})
    },
    service : chatGroupAddViewService,
    parse : function(resp) {
        return resp;
    },
    validate : function(attrs, options) {
         if (attrs.perCount < 2) {
             return "请选择群成员";
         }else if(attrs.perCount == 2){
            var perArr = JSON.parse(appcan.getLocVal("personArr"));
            var userId = (perArr[0].userId).toLowerCase();
            var fullName = perArr[0].fullName;
            appcan.setLocVal("yghao",userId);
            appcan.setLocVal("contactsName",fullName);
            appcan.window.evaluateScript('qunzuadd','close()');
            uexWidget.startWidget("IM","10","","huihuadanliao1.html","300");
            return '单聊';
        }else{
            if((!attrs.groupName)){
                return "请输入群名称";
            }
            if(!(/^(\w|[\u4E00-\u9FA5]){1,20}$/).test(attrs.groupName)){
              return "群名称为中文、英文或数字组合1-20个字符";
            }
         }
    },
    sync : function(method, model, options) {
        switch(method) {
        case "create":
            options.params = {
                data : this.toJSON()  
            }  
            chatGroupAddViewService.request(options);
        case "update":
        case "patch":
            break;
        case "read":
            break;
        case "delete":
            break;
        default:
            break;
        }
    }
})