var chatModel = Backbone.Model.extend({
    idAttribute : "imId"
})

var chatCollection = Backbone.Collection.extend({
    initialize : function() {
        this.listenTo(chatListViewService, "E_XMPP_GETCHAT_RES", function(list) {
            if (this.options) {
                //var d = JSON.parse(list);
                this.options.success(list.dataList);
            }
        })
       // this.reset(JSON.parse(appcan.locStorage.getVal("CHATLIST_STORAGE")|| "[]") );
    },
    comparator :"timestamp", 
    // function(m1, m2) {
        // return m1.attributes.price > m2.attributes.price ? -1 * this.orderBy : 1 * this.orderBy;
    // }
    model : chatModel,
    service : chatListViewService, //服务，负责处理数据交互
    parse : function(resp) {
        return resp;
    },
    sync : function(method, model, options) {
        this.options = options;
        switch(method) {
        case "create":
        case "update":
        case "patch":
            break;
        case "read":
            chatListViewService.request({}, options);
            break;
        case "delete":
            break;
        default:
            break;
        }
    }
})
