var todoModel = Backbone.Model.extend({
    idAttribute : "objectId",
    service : requestService,
    parse : function(model) {
        var obj = {};
        // if (model.status) {
            // obj = model.msg.item.entity;
            // obj.id = model.msg.item.objectId;
            // obj.createdAt = model.msg.item.createdAt;
            // this.set('id', obj.id);
            // return obj;
        // }
        return model;
    },
    sync : function(method, model, options) {
        switch(method) {
        case "create":
        case "update":
        case "patch":
            break;
        case "read":
            this.service.request(options);
            break;
        case "delete":
            break;
        default:
            break;
        }
    }
});

var todoCollection = Backbone.Collection.extend({
    model : todoModel, //集合对应模型
    service : requestService, //服务，负责处理数据交互
    parse : function(resp) {
        return resp.msg.list;
    },
    sync : function(method, model, options) {
        switch(method) {
        case "create":
        case "update":
        case "patch":
            break;
        case "read":
            this.service.request(options);
            break;
        case "delete":
            break;
        default:
            break;
        }
    }
})