
var myPointService = {
    request : function(option){
        
        var dataObj = JSON.stringify(option.param);
        appcan.request.ajax({
            url : constant.APP_URL,
            headers : JSON.parse(get_header()),
            data : dataObj,
            type : "POST",
            timeout : "30000",
            contentType : "application/json",
            success : function(data){
                try {
                    data = JSON.parse(data);
                    if(mas_result_do(data)){
                        option.error(data);
                    } else if (data.status == "000") {
                        option.success(data);
                    } else {
                        option.error(data);
                    }
                } catch(e) {
                    option.error({status:-30000,msg:{message:"服务器返回数据异常，请联系管理员"}});
                }
            },
            error : function(err) {
                option.error({status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
            }
        })
    }
}

_.extend(myPointService, Backbone.Events);
