var requestService = {
    lock : false,
    request : function(options) {
        var self = this;
        if (self.lock) {
            self.trigger("error", "Request alreay running. Please wait");
            return;
        }
        var _url = options.params.url || url;
        self.lock = true;
        appcan.request.ajax({
            url : _url,
            headers : JSON.parse(get_header()),
            data : JSON.stringify(options.params.data),
            type : "POST",
            timeout : "30000",
            contentType : "application/json",
            success : function(data) {
                self.lock = false;
                try {
                    if(typeof data === 'string'){
                        data = JSON.parse(data);
                    }
                    
                    if(mas_result_do(data)){
                        options.error(data);
                    } else if (data.status == "000") {
                        options.success(data);
                    } else {
                        options.error(data);
                    }
                } catch(e) {
                    //alert(e.stack);
                    options.error({status:-30000,msg:{message:"服务器返回数据异常，请联系管理员"}});
                }
            },
            error : function(XMLHttpRequest, textStatus, errorThrown) {
                //alert('requestService over'+JSON.stringify(options.params.data));
                self.lock = false;
                options.error({status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
            }
        });

    },readRequest:function(param){
        var self = this;
        var _url = param.url || url;
         appcan.request.ajax({
            url : _url,
            headers : JSON.parse(get_header()),
            data : JSON.stringify(param.param),
            type : "POST",
            timeout : "30000",
            contentType : "application/json",
            success : function(data) {
                if(typeof data === 'string'){
                    data = JSON.parse(data);
                }
                if (data.status == "000") {
                    if(param.param.content.objectId){
                        data.msg.objectId = param.param.content.objectId;
                    }
                    self.trigger("fresh", data.msg);
                }
            },
            error:function(err){
            }
            })
    }
};

var multiRequestService = {
    request : function(options) {
        var self = this;
        var _url = options.params.url || url;
        $.ajax({
            url : _url,
            headers : JSON.parse(get_header()),
            data : JSON.stringify(options.params.data),
            type : "POST",
            timeout : "30000",
            contentType : "application/json",
            success : function(data) {
                try {
                    if(typeof data === 'string'){
                        data = JSON.parse(data);
                    }
                    if(mas_result_do(data)){
                        options.error(data);
                    } else if (data.status == "000") {
                        options.success(data);
                    } else {
                        options.error(data);
                    }
                } catch(e) {
                    //alert(e.stack);
                    options.error({status:-30000,msg:{message:"服务器返回数据异常，请联系管理员"}});
                }
            },
            error : function(err) {
                //alert('multiRequestService over'+JSON.stringify(options.params.data));
                options.error({status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
            }
        });

    }
};

_.extend(requestService, Backbone.Events);

