var tplBaseUrl = "";
var config = appcan.getLocVal("EPORTAL_CONFIG");
config = JSON.parse(config);
var masUrl = config.mas_emm;
function loadTemplate(tpl) {
    var template = null;
    $.ajax({
        url : tplBaseUrl + tpl,
        type : 'GET',
        data : {}, //默认从参数获取
        timeout : 10000,
        async : false,
        success : function(data) {
            template = _.template(data);
        },
        error : function(e) {
        }
    });
    return template;
}

var constant = {
    INTERFACE_LOGIN : "http://www.appcan.cn",
    IMG_URL : masUrl + "",
    APP_URL : masUrl + "emoa/app",
    LOGIN_URL : masUrl + "emoa/appLogin",
    APP_ID:'EPortal'
}
var storeKey = {
    PERSON_INFO:"perInfo",
    PERSON_INFO_ICON:"userIconUrlIndex",
    PERSON_ID:"yghao",
    PERSON_NAME:"ygname",
    CONTACT_NAME:"contactsName",
    CONTACT_ICON:"conImg"
}
var tools = {
    TEL_REG : /^1[3|4|5|7|8][0-9]\d{4,8}$/,//手机
    EMAIL_REG :  /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/,
    PHONE_REG : /^([0-9]{3,4}-)?[0-9]{7,8}$/,//座机
    URL_HREF : /(https?:\/\/|ftps?:\/\/)?((\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})(:[0-9]+)?|(localhost)(:[0-9]+)?|([\w]+\.)(\S+)(\w{2,4})(:[0-9]+)?)(\/?([\w#!:.?+=&%@!\-\/]+))?/ig,
    TEL_PHONE_REG : /(\(\d{3,4}\)|\d{3,4}-|\s)?\d{7,14}/g,
    IM_EXPRESSION : /\[([^\]]+)\]/g   //IM表情
}
function ALERT_ERROR(mod, fun, msg) {
    //window.alert(mod + "\r\n" + fun + "\r\n" + msg);
}

function global_error(error) {
    appcan.window.openToast(error.msg.message, 1500, 5);
}
function getHeader() {
    return JSON.stringify({
        "x-mas-app-id" : constant.APP_ID
    });

}
//当前时间的时间戳
function getTime() {
    return new Date().getTime();
}

/**
 * JavaScrit 版本
 * 将URL地址转化为完整的A标签链接代码
 */
var replaceURLToLink = function (text) {
        text = text.replace(tools.URL_HREF, function (url) {
            var urlText = url;
            if (!url.match('^https?:\/\/')) {
                url = 'http://' + url;
            }
            return '<a href="javascript:void(0);" class="urlGO" data-data="' + encodeURIComponent(url) + '">' + urlText + '</a>';
        });
        return text;
    };
/**
 * JavaScrit 版本
 * 将电话号码替换可直接拨打的代码链接代码
 */
var replacePhoneToCall = function (text) {
        // text = text.replace(tools.TEL_PHONE_REG, function (url) {
        //     return '<a href="tel://' + url + '">' + url + '</a>';
        // });
        return text;
    };

/**
 *service的基础对象，供其他service调用
 */
var BaseService = {
    /**
     *获取请求锁
     * @param {Object} string
     */
    getLockKey : function(string) {
        if (string) {
            //有option对象，把它变成字符串
            string = encodeURI(string);
            var md5 = appcan.crypto.md5(string);
            return md5;
        }
    },
    emmCall:function(url, type, data, option){

    },
    /**
     *简化普通请求
 * @param {Object} url
 * @param {Object} type
 * @param {Object} data
 * @param {Object} option
     */
    ajaxCall : function(url, type, data, option) {
        var self = this;
        var lockKey = self.getLockKey(JSON.stringify(data));
        if (self[lockKey]) {
            //如果锁定请求的话，不再提交
            self.trigger("error", "Request alreay running. Please wait");
            return;
        }
        //加请求锁
        self[lockKey] = true;
        //调试的话，建议用$.ajax，生产环境可以用appcan.ajax
        //$.ajax({
        appcan.request.ajax({
            url : url,
            type : type,
            data : data,
            header:getHeader(),
            contentType : "application/json",
            success : function(data) {
                data=JSON.parse(data);
                self[lockKey] = false;
                if (data.status == '000') {
                    option.success(data);
                } else {
                    option.error(new Error(data.message));
                }
            },
            error : function(e, err) {
                self[lockKey] = false;
                option.error(new Error(err));
            }
        });
    }
};
_.extend(BaseService, Backbone.Events);

function getHeaders(){
    var curTime = Date.now();
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    var headerParam = {
        "x-mas-app-id" : appId,
        "accessToken":accessToken
    }
    return headerParam;
}

//滚动条在Y轴上的滚动距离
function getScrollTop(){
　　var scrollTop = 0, bodyScrollTop = 0, documentScrollTop = 0;
　　if(document.body){
　　　　bodyScrollTop = document.body.scrollTop;
　　}
　　if(document.documentElement){
　　　　documentScrollTop = document.documentElement.scrollTop;
　　}
　　scrollTop = (bodyScrollTop - documentScrollTop > 0) ? bodyScrollTop : documentScrollTop;
　　return scrollTop;
}
//文档的总高度
function getScrollHeight(){
　　var scrollHeight = 0, bodyScrollHeight = 0, documentScrollHeight = 0;
　　if(document.body){
　　　　bodyScrollHeight = document.body.scrollHeight;
　　}
　　if(document.documentElement){
　　　　documentScrollHeight = document.documentElement.scrollHeight;
　　}
　　scrollHeight = (bodyScrollHeight - documentScrollHeight > 0) ? bodyScrollHeight : documentScrollHeight;
　　return scrollHeight;
}
//浏览器视口的高度
function getWindowHeight(){
　　var windowHeight = 0;
　　if(document.compatMode == "CSS1Compat"){
　　　　windowHeight = document.documentElement.clientHeight;
　　}else{
　　　　windowHeight = document.body.clientHeight;
　　}
　　return windowHeight;
}
