var contactsInfoView = Backbone.View.extend({//options...
    initialize : function() {
        try{
        this.model = new userInfoModel({}, {
                    userId : appcan.getLocVal(storeKey.PERSON_ID)
                });
        this.updateData();
        this.listenTo(this.model, "change", this.updateData);
        }catch(e){alert(e.message)}
        return this;
    },
    //model:new userInfoModel(),
    el : '#userInfo',
    load : function() {
        appcan.frame.resetBounce(0);
        return;
        var staffId = appcan.getLocVal(storeKey.PERSON_ID);
        this.model.fetch({
            success : function(model, resp, options) {
                appcan.frame.resetBounce(0);
            },
            error : function(model, error, options) {
                appcan.frame.resetBounce(0);
            },staffId:staffId
        });
    },
    updateData : function(a,b){
        try{
        var  info = this.model.toJSON();
        var imgIcon = info.userIcon;
        var fullName = info.fullName;
        var department=info.department&&info.department[0]&&info.department[0].dptName || info.dptName || "";//职位
        var roleName=info.position&&info.position[0]&&info.position[0].roleName || info.roleName || "";//职位
        var leader=info.leader&&info.leader[0]&&info.leader[0].ldrFullName || info.ldrFullName || "";//上级
        appcan.setLocVal(storeKey.CONTACT_ICON, imgIcon);
        if(imgIcon){
            $("div.lazy").data("original", constant.IMG_URL + imgIcon);
             appcan.ready(function(){
                 $("div.lazy").lazyload({
                     cache : true
                 });
             })
        }
        appcan.setLocVal(storeKey.CONTACT_NAME, fullName);
        $("#fullName").html(fullName);
        var userId = info.userId;
        appcan.setLocVal(storeKey.PERSON_ID, userId);
        // $("#userId").html(userId);
        $("#roleName").html(roleName);
        $('#department').html(department);
        if(!isDefine(info.teleNo)){
           $("#teleNo").html("　");
        }else{
          $("#teleNo").html(info.teleNo);
        }
        if(!isDefine(info.mobileNo)){
           $("#mobileNo").html("　");
        }else{
           $("#mobileNo").html(info.mobileNo);
        }
        if(!isDefine(info.email)){
           $("#email").html("　");
        }else{
           $("#email").html(info.email);
        }
        $("#leader").html(leader);
        this.bindingEvent();
        }catch(e){
            alert(e.stack+e.message)
        }
    },
    bindingEvent:function(){
        var self = this;

        appcan.button("#mobile", "btn-act", function() {
            var phone = self.model.get("mobileNo");
            if (isDefine(phone)) {
                uexWindow.cbActionSheet = function(a, b, data) {
                    if (data == "0") {//发短信
                        uexSMS.open(phone, "");
                    } else if (data == "1") {//打电话
                        uexCall.dial(phone);
                    }
                }
                var str = ["发短信给" + phone + "", "打电话给" + phone + ""];
                uexWindow.actionSheet("菜单", "取消", str);
            }
        })

        appcan.button("#youxiang","btn-act",function(){
            var email = self.model.get("email")
            if (isDefine(email)) {
                uexEmail.open(email,"","","");
            }
        })
        // appcan.button("#phone","btn-act",function(){
        //     var teleNo = self.model.get("teleNo")
        //     if (isDefine(teleNo)) {
        //         uexCall.dial(teleNo);
        //     }
        // })
    }
});
var contactsInfoViewInstance = new contactsInfoView();
