function getHeaders(){
    var curTime = Date.now();
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    var tenantId = emmToken.info.tenantId || "";
    var headerParam = {
        "x-mas-app-id" : appId,
        "accessToken":accessToken
    }
    if(tenantId){
        headerParam.tenantId = tenantId+'';
    }
    return headerParam;
}
function personInfoEmm(staffId,callback){
    var uid = staffId
    try{
    var msgObj = {
        status:"000",
        msg:{
            item:{
                userId:"",
                entity:{}
            }
        }
    }
     var userToken = appcan.getLocVal('userToken');
    appcan.logs("staffId--" + staffId)
    if(staffId.indexOf("zyyd") > -1 ){
        staffId = staffId.split('zyyd')[0]
        var url = server_url + '/user/getDeptUserById';
    }else{
        var url = server_url + '/user/getUserById';
    }

     var d1 = JSON.stringify({
                    "token" : userToken,
                    "userid" : staffId


                });

    appcan.request.ajax({
    url : url,
                    type : 'POST',
                    data : d1,
                    dataType : 'json',
                    contentType : 'application/json',
    success : function(data, status, xhr) {

        if(data.result == "SUCCESS"){
            appcan.logs("user/getUserById--" + JSON.stringify(data))
            var headurl = ''
            var fullName
            var mobileNo
            var teleNo
 if (isDefine(data.data && data.data.pic_url)) {
    if(uid.indexOf("zyyd") > -1 ){
     headurl = picture_url + '/' + data.data.pic_url.replace(/\\/g, '/') + '/' + data.data.pic_name
            }else{
                    headurl = server_url + '/' + data.data.pic_url.replace(/\\/g, '/') + '/' + data.data.pic_name
            }


    }
 if (isDefine(data.data && data.data.user_name)) {
         fullName =  data.data.user_name

    }
if (isDefine(data.data && data.data.telephone)) {
         mobileNo =  data.data.telephone

    }
if (isDefine(data.data && data.data.birthday)) {
         teleNo =  data.data.birthday.split(' ')[0]

    }
            var dptPerObj = {
                userId : uid,
                fullName : fullName,
                sexId : '',
                mobileNo : mobileNo,
                email : '',
                loginName : '',
                teleNo : teleNo,
                userIcon : headurl,
                roleId : '',
                roleName : '',
                brcId : '',
                dptId : '',
                brcName : '',
                dptName : '',
                ldrUserId : '',
                ldrFullName : '',
                positionTypeId : '',
                positionTypeName : ''
            }
            appcan.logs("dptPerObj--" + JSON.stringify(dptPerObj))
        msgObj.msg.item.userId = data.data.userid;
        msgObj.msg.item.entity= dptPerObj;
        }

        callback(null,msgObj);
    },
    error : function(xhr, errorType, error,msg) {
        callback(-1000,{status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
        //appcan.window.openToast("网络解析出错", 4500, 5);
        appcan.logs("getUserByIderror")
    }
    });
    }catch(e){alert(e)}
}
function editPerInfoEmm(staffId,infoObj,callback){
    var dataObj = {
        status:""
    }
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    var url = contactUrl+'updatePersonnelByUniqueField?accessToken='+accessToken+'&mobileNo='+encodeURIComponent(infoObj.mobileNo)+'&officePhone='+encodeURIComponent(infoObj.teleNo)+'&email='+encodeURIComponent(infoObj.email)+'&userSex='+infoObj.userSex+'&avatorLoc='+infoObj.avatorLoc+'&uniqueField='+staffId+'&domainName='+encodeURIComponent(domainName);
    appcan.request.ajax({
    url : url,
    type : 'GET',
    headers : getHeaders(),
    contentType : 'application/x-www-form-urlencoded',
    timeout : "30000",
    data : {},
    success : function(data, status, xhr) {
        appcan.frame.resetBounce(0);
        appcan.frame.resetBounce(1);
        var data = JSON.parse(data);
        if(data.status=="ok"){
            var status = "000";
            dataObj.status=status;
            callback(null,dataObj);
        }else{
            var status = "001";
            dataObj.status=status;
            callback(null,dataObj);
        }
    },
    error : function(data) {
        appcan.frame.resetBounce(0);
        appcan.frame.resetBounce(1);
        var status = "001";
        dataObj.status=status;
        callback(-1000,{status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
        //appcan.window.openToast("网络解析出错", 4500, 5);
    }
    });
}
function loginPerInfoEmm(staffId,callback){
    var msgObj = {
        "status":"000",
        loginUser:{
            entity:{}
        }
    }
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    var url = contactUrl+'getByUniqueField?accessToken='+accessToken+'&uniqueField='+staffId+'&domainName='+encodeURIComponent(domainName);
    appcan.request.ajax({
    url : url,
    type : 'GET',
    headers : getHeaders(),
    contentType : 'application/x-www-form-urlencoded',
    timeout : "30000",
    data : {},
    success : function(data, status, xhr) {
        try{
        appcan.frame.resetBounce(0);
        appcan.frame.resetBounce(1);
        var data = JSON.parse(data);
        if(data[0]){
            var uniqueField = data[0].uniqueField;//userId
            var name = data[0].name;//fullName
            if(isSaas){
                var avatorLoc = data[0].avatorLoc
            }else{
                var avatorLoc0 = data[0].avatorLoc.split("/");//userIcon
                var avatorLoc = avatorLoc0[(avatorLoc0.length-1)];
            }
            var topOrgIds = data[0].topOrgIds;//brcId
            var orgIds = data[0].orgIds;//dptId
            var dptPerObj = {
                userId : uniqueField,
                fullName : name,
                userIcon : avatorLoc,
                department:[{dptId:orgIds}],
                brcId : topOrgIds
            }
        }
        msgObj.loginUser.entity = dptPerObj;
        }catch(e){
            alert(e.message)
        }
        callback(null,msgObj);
    },
    error : function(data) {
        appcan.frame.resetBounce(0);
        appcan.frame.resetBounce(1);
        callback(-1000,{status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
        //appcan.window.openToast("网络解析出错", 4500, 5);
    }
    });
}

function perAllBydpt(dptId,callback){
    var msgObj = {
        msg:[],
        status:"000"
    }
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    appcan.request.ajax({
        url : contactUrl+'getPersonnelByOrgId?accessToken='+accessToken+'&orgId='+dptId+'&domainName='+encodeURIComponent(domainName),
        type : 'GET',
        headers : getHeaders(),
        contentType : 'application/x-www-form-urlencoded',
        timeout : "30000",
        data : {},
        success : function(data, status, xhr) {
             var data = JSON.parse(data);
            var dptPerArr = [];
            for(var j = 0;j<data.length;j++){
                var orgName = data[j].orgName;//brcName/dptName
                var dptName = "";
                if(orgName){
                   var orgNames = orgName.split(",");
                   var orgNameArr = orgNames[0].split("/");
                   var brcName = orgNameArr[0];//机构名称
                   dptName = orgNameArr[orgNameArr.length - 1]; //部门名称
                }
                var personnelId = data[j].personnelId;//id
                var uniqueField = data[j].uniqueField;//userId
                var name = data[j].name;//fullName
                var userSex = data[j].userSex;//sexId
                if(userSex == "male"){
                   var userSex = "01";
                }else if(userSex == "female"){
                    var userSex = "02";
                }
                var mobileNo = data[j].mobileNo;//mobileNo手机号
                var email = data[j].email;//email邮箱
                var loginName = data[j].loginName;//loginName登陆姓名
                var officePhone = data[j].officePhone;//teleNo办公电话
                if(isSaas){
                    var avatorLoc = data[j].avatorLoc
                }else{
                    var avatorLoc0 = data[j].avatorLoc.split("/");//userIcon
                    var avatorLoc = avatorLoc0[(avatorLoc0.length-1)];
                }
                var jobId = data[j].jobId;//roleId
                var jobName = data[j].jobName;//roleName
                var jobName1 = "";
                if(jobName){
                    var jobArr = jobName.split(",");
                    jobName1 = jobArr[0];
                }
                var topOrgIds = data[j].topOrgIds;//brcId
                var orgIds = data[j].orgIds;//dptId
                var higherLevelUniqueField = data[j].higherLevelUniqueField;//ldrUserId
                var higherLevelName = data[j].higherLevelName;//ldrFullName
                var leadname="";
                if(higherLevelName){
                   leadname = higherLevelName.split(",")[0];
                }
                var positionTypeId = data[j].positionTypeId;//positionTypeId
                var positionTypeName = data[j].positionTypeName;
                var dptPerObj = {
                    userId : uniqueField,
                    fullName : name,
                    sexId : userSex,
                    mobileNo : mobileNo,
                    email : email,
                    loginName : loginName,
                    mobileNo : mobileNo,
                    teleNo : officePhone,
                    userIcon : avatorLoc,
                    roleId : jobId,
                    roleName : jobName1,
                    brcId : topOrgIds,
                    dptId : orgIds,
                    brcName : brcName,
                    dptName : dptName,
                    ldrUserId : higherLevelUniqueField,
                    ldrFullName : leadname,
                    positionTypeId : positionTypeId,
                    positionTypeName : positionTypeName
                }
                dptPerArr.push(dptPerObj);
            }
            msgObj.msg = dptPerArr;
            callback(null,msgObj);
        },
        error : function(data) {
            callback(-1000,{status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
        }
    });
}
function selAllPerByEmm(uname,callback){
    var msgObj = {
        msg:[],
        status:"000"
    }
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    var indexInfo = JSON.parse(appcan.getLocVal("EMM_USER_INFO"));
    var brcId = indexInfo.loginUser.entity.brcId;
    appcan.request.ajax({
        url : contactUrl+'getPersonnelByName?accessToken='+accessToken+'&userName='+encodeURIComponent(uname)+'&domainName='+encodeURIComponent(domainName)+"&orgId="+brcId,
        type : 'get',
        headers : getHeaders(),
        contentType : 'application/x-www-form-urlencoded',
        timeout : "30000",
        data : {},
        success : function(data, status, xhr) {
             var data = JSON.parse(data);
            var dptPerArr = [];
            for(var j = 0;j<data.length;j++){
                var orgName = data[j].orgName;//brcName/dptName
                var dptName = "";
                if(orgName){
                   var orgNames = orgName.split(",");
                   var orgNameArr = orgNames[0].split("/");
                   var brcName = orgNameArr[0];//机构名称
                   dptName = orgNameArr[orgNameArr.length - 1]; //部门名称
                }
                var personnelId = data[j].personnelId;//id
                var uniqueField = data[j].uniqueField;//userId
                var name = data[j].name;//fullName
                var userSex = data[j].userSex;//sexId
                var userSex = data[j].userSex;//sexId
                if(userSex == "male"){
                   var userSex = "01";
                }else if(userSex == "female"){
                    var userSex = "02";
                }
                var mobileNo = data[j].mobileNo?data[j].mobileNo:"";//mobileNo手机号
                var email = data[j].email?data[j].email:"";//email邮箱
                var loginName = data[j].loginName;//loginName登陆姓名
                var officePhone = data[j].officePhone;//teleNo办公电话
                if(isSaas){
                    var avatorLoc = data[j].avatorLoc
                }else{
                    var avatorLoc0 = data[j].avatorLoc.split("/");//userIcon
                    var avatorLoc = avatorLoc0[(avatorLoc0.length-1)];
                }
                var jobId = data[j].jobId;//roleId
                var jobName = data[j].jobName;//roleName
                var jobName1="";
                if(jobName){
                    var jobArr = jobName.split(",");
                    jobName1 = jobArr[0];
                }
                var topOrgIds = data[j].topOrgIds;//brcId
                var orgIds = data[j].orgIds;//dptId
                var higherLevelUniqueField = data[j].higherLevelUniqueField;//ldrUserId
                var higherLevelName = data[j].higherLevelName;//ldrFullName
                var leadname="";
                if(higherLevelName){
                    leadname = higherLevelName.split(",")[0];
                }
                var positionTypeId = data[j].positionTypeId;//positionTypeId
                var positionTypeName = data[j].positionTypeName;
                var dptPerObj = {
                    userId : uniqueField,
                    fullName : name,
                    sexId : userSex,
                    mobileNo : mobileNo,
                    email : email,
                    loginName : loginName,
                    mobileNo : mobileNo,
                    teleNo : officePhone,
                    userIcon : avatorLoc,
                    roleId : jobId,
                    roleName : jobName1,
                    brcId : topOrgIds,
                    dptId : orgIds,
                    brcName : brcName,
                    dptName : dptName,
                    ldrUserId : higherLevelUniqueField,
                    ldrFullName : leadname,
                    positionTypeId : positionTypeId,
                    positionTypeName : positionTypeName
                }
                dptPerArr.push(dptPerObj);
            }
            msgObj.msg = dptPerArr;
            callback(null,msgObj);
        },
        error : function(data) {
            callback(-1000,{status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
        }
    });
}

function getInfosByUniqueFieldsEmm(uniqueFields,callback){
    var msgObj = {
            msg:[],
            status:"000"
        };
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    var url = contactUrl+'getByUniqueFieldArr?accessToken='+accessToken+'&uniqueField='+uniqueFields+'&domainName='+encodeURIComponent(domainName);
    appcan.request.ajax({
    url : url,
    type : 'GET',
    headers : getHeaders(),
    contentType : 'application/x-www-form-urlencoded',
    timeout : "30000",
    data : {},
    success : function(data, status, xhr) {
        var data = JSON.parse(data);
        var infoArr=[];
        for(var j=0;j<data.length;j++){
            var orgName = data[j].orgName;//brcName/dptName
            var dptName = "";
            if(orgName){
               var orgNames = orgName.split(",");
               var orgNameArr = orgNames[0].split("/");
               var brcName = orgNameArr[0];//机构名称
               dptName = orgNameArr[orgNameArr.length - 1]; //部门名称
            }
            var personnelId = data[j].personnelId;//id
            var uniqueField = data[j].uniqueField;//userId
            var name = data[j].name;//fullName
            var userSex = data[j].userSex;//sexId
            if(userSex == "male"){
               var userSex = "01";
            }else if(userSex == "female"){
                var userSex = "02";
            }
            var mobileNo = data[j].mobileNo;//mobileNo手机号
            var email = data[j].email;//email邮箱
            var loginName = data[j].loginName;//loginName登陆姓名
            var officePhone = data[j].officePhone;//teleNo办公电话
            if(isSaas){
                var avatorLoc = data[j].avatorLoc
            }else{
                var avatorLoc0 = data[j].avatorLoc.split("/");//userIcon
                var avatorLoc = avatorLoc0[(avatorLoc0.length-1)];
            }
            var jobId = data[j].jobId;//roleId
            var jobName = data[j].jobName;//roleName
            var jobName1 = "";
            if(jobName){
                var jobArr = jobName.split(",");
                jobName1 = jobArr[0];
            }
            var topOrgIds = data[j].topOrgIds;//brcId
            var orgIds = data[j].orgIds;//dptId
            var higherLevelUniqueField = data[j].higherLevelUniqueField;//ldrUserId
            var higherLevelName = data[j].higherLevelName;//ldrFullName
            var leadname="";
            if(higherLevelName){
               leadname = higherLevelName.split(",")[0];
            }
            var positionTypeId = data[j].positionTypeId;//positionTypeId
            var positionTypeName = data[j].positionTypeName;
            var obj = {
                userId : uniqueField,
                fullName : name,
                sexId : userSex,
                mobileNo : mobileNo,
                email : email,
                loginName : loginName,
                mobileNo : mobileNo,
                teleNo : officePhone,
                userIcon : avatorLoc,
                roleId : jobId,
                roleName : jobName1,
                brcId : topOrgIds,
                dptId : orgIds,
                brcName : brcName,
                dptName : dptName,
                ldrUserId : higherLevelUniqueField,
                ldrFullName : leadname,
                positionTypeId : positionTypeId,
                positionTypeName : positionTypeName
            }
            infoArr.push(obj);
        }
        msgObj.msg = infoArr;
        callback(null,msgObj);
    },
    error : function(data) {
        var status = "001";
        dataObj.status=status;
        callback(-1000,{status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
        //appcan.window.openToast("网络解析出错", 4500, 5);
    }
    });
}
