function getHeaders(){
    var curTime = Date.now();
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    var tenantId = emmToken.info.tenantId || "";
    var headerParam = {
        "x-mas-app-id" : appId,
        "accessToken":accessToken
    }
    if(tenantId){
        headerParam.tenantId = tenantId+'';
    }
    return headerParam;
}
function personInfoEmm(staffId,callback){
    var msgObj = {
        msg:{
            item:{
                userId:"",
                entity:{}
            }
        }
    }
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    appcan.request.ajax({
    url : contactUrl+'getByUniqueField?accessToken='+accessToken+'&uniqueField='+staffId+'&domainName='+encodeURIComponent(domainName),
    type : 'GET',
    headers : getHeaders(),
    contentType : 'application/x-www-form-urlencoded',
    timeout : "30000",
    data : {},
    success : function(data, status, xhr) {
        appcan.frame.resetBounce(0);
        appcan.frame.resetBounce(1);
        var data = JSON.parse(data);
        if(data[0]){
            var orgName = data[0].orgName?data[0].orgName.split(","):[];//brcName/dptName
            if(orgName.length>0){
                var dptArr=[];
                for(var n=0;n<orgName.length;n++){
                    var dptname = orgName[n].split("/");
                    var dptname1 = dptname[dptname.length-1];
                    var nameObj = {
                        dptName:dptname1
                    }
                    dptArr.push(nameObj);
                }
            }else{
               var dptArr=[]; 
            }
            var personnelId = data[0].personnelId;//id
            var uniqueField = data[0].uniqueField;//userId
            var name = data[0].name;//fullName
            var sex = data[0].userSex;//sexId
            if(sex == "male"){
               var userSex = "01"; 
            }else if(sex == "female"){
                var userSex = "02";
            }
            var mobileNo = data[0].mobileNo;//mobileNo手机号
            var email = data[0].email;//email邮箱
            var loginName = data[0].loginName;//loginName登陆姓名
            var officePhone = data[0].officePhone;//teleNo办公电话
            if(isSaas){
                var avatorLoc = data[0].avatorLoc
            }else{
                var avatorLoc0 = data[0].avatorLoc.split("/");//userIcon
                var avatorLoc = avatorLoc0[(avatorLoc0.length-1)];
            }
            var jobId = data[0].jobId;//roleId
            var jobName = data[0].jobName?data[0].jobName.split(","):[];//roleName
            var jobNameArr = [];
            if(jobName.length>0){
               for(var m=0;m<jobName.length;m++){
                    var role = jobName[m];
                    var roleObj = {
                        roleName : role
                    }
                   jobNameArr.push(roleObj); 
                } 
            }
            var topOrgIds = data[0].topOrgIds;//brcId
            var orgIds = data[0].orgIds;//dptId
            var higherLevelUniqueField = data[0].higherLevelUniqueField;//ldrUserId
            var higherLevelName = data[0].higherLevelName?data[0].higherLevelName.split(","):[];//ldrFullName
            var leadNameArr = [];
            if(higherLevelName.length>0){
               for(var d=0;d<higherLevelName.length;d++){
                    var leadname = higherLevelName[d];
                    var leadObj = {
                        ldrFullName : leadname
                    }
                   leadNameArr.push(leadObj); 
                } 
            }
            var positionTypeId = data[0].positionTypeId;//positionTypeId
            var positionTypeName = data[0].positionTypeName;
            var dptPerObj = {
                userId : uniqueField,
                fullName : name,
                sexId : userSex,
                mobileNo : mobileNo,
                email : email,
                loginName : loginName,
                mobileNo : mobileNo,
                teleNo : officePhone,
                userIcon : avatorLoc,
                roleId : jobId,
                position : jobNameArr,
                brcId : topOrgIds,
                dptId : orgIds,
                department : dptArr,
                ldrUserId : higherLevelUniqueField,
                leader : leadNameArr,
                positionTypeId : positionTypeId,
                positionTypeName : positionTypeName
            }
        }
        msgObj.msg.item.userId = uniqueField;
        msgObj.msg.item.entity= dptPerObj;
        callback(null,msgObj);
    },
    error : function(data) {
        appcan.frame.resetBounce(0);
        appcan.frame.resetBounce(1);
        callback(new Error("网络解析出错"));
        appcan.window.openToast("网络解析出错", 4500, 5);
    }
    });
}
function editPerInfoEmm(staffId,infoObj,callback){
    var dataObj = {
        status:""
    }
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    appcan.request.ajax({
    url : contactUrl+'updatePersonnelByUniqueField?accessToken='+accessToken+'&mobileNo='+encodeURIComponent(infoObj.mobileNo)+'&officePhone='+encodeURIComponent(infoObj.teleNo)+'&email='+encodeURIComponent(infoObj.email)+'&userSex='+infoObj.userSex+'&avatorLoc='+infoObj.avatorLoc+'&uniqueField='+staffId+'&domainName='+encodeURIComponent(domainName),
    type : 'GET',
    headers : getHeaders(),
    contentType : 'application/x-www-form-urlencoded',
    timeout : "30000",
    data : {},
    success : function(data, status, xhr) {
        appcan.frame.resetBounce(0);
        appcan.frame.resetBounce(1);
        var data = JSON.parse(data);
        if(data.status=="ok"){
            var status = "000";
            dataObj.status=status;
            callback(null,dataObj);
        }else{
            var status = "001";
            dataObj.status=status;
            callback(null,dataObj);
        }
    },
    error : function(data) {
        appcan.frame.resetBounce(0);
        appcan.frame.resetBounce(1);
        var status = "001";
        dataObj.status=status;
        callback(null,dataObj);
        appcan.window.openToast("网络解析出错", 4500, 5);
    }
    });
}
function loginPerInfoEmm(staffId,callback){
    var msgObj = {
        loginUser:{
            entity:{}
        }
    }
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    appcan.request.ajax({
    url : contactUrl+'getByUniqueField?accessToken='+accessToken+'&uniqueField='+staffId+'&domainName='+encodeURIComponent(domainName),
    type : 'GET',
    headers : getHeaders(),
    contentType : 'application/x-www-form-urlencoded',
    timeout : "30000",
    data : {},
    success : function(data, status, xhr) {
        appcan.frame.resetBounce(0);
        appcan.frame.resetBounce(1);
        var data = JSON.parse(data);
        if(data[0]){
            var uniqueField = data[0].uniqueField;//userId
            var name = data[0].name;//fullName
            if(isSaas){
                var avatorLoc = data[0].avatorLoc
            }else{
                var avatorLoc0 = data[0].avatorLoc.split("/");//userIcon
                var avatorLoc = avatorLoc0[(avatorLoc0.length-1)];
            }
            var topOrgIds = data[0].topOrgIds;//brcId
            var orgIds = data[0].orgIds;//dptId
            var personnelId = data[0].personnelId;
            var dptPerObj = {
                userId : uniqueField,
                fullName : name,
                userIcon : avatorLoc,
                department:[{dptId:orgIds}],
                brcId : topOrgIds,
                personnelId:personnelId,
            }
        }
        msgObj.loginUser.entity = dptPerObj;
        callback(null,msgObj);
    },
    error : function(data) {
        appcan.frame.resetBounce(0);
        appcan.frame.resetBounce(1);
        callback(new Error("网络解析出错"));
        appcan.window.openToast("网络解析出错", 4500, 5);
    }
    });
}