var events = {};
function thirdPlugin(type,param,callback){
    if(!events[type]|| events[type].length==0){
        callback(null,null);
        return;
    }
    var plugins =[];
    Zepto.each(events[type],function(i,v){
        plugins.push(
            function(cb){
                events[type][i](param,function(data){
                    cb(null,data);
                });
            }
        );
    });
    async.series(plugins,function(error,result){
            if(!error)
                callback(null,result);
            else
                callback(error,null);
        });
}

function setThirdPlugin(type,cb,param){
    var e = events[type] || [];
    e.push(cb);
    events[type] = e;
}
